subroutine Compute_Courant (Tdomain)
use sdomain
implicit none
include "mpif.h"
! Modified by Gaetano Festa 13/10/2005

type (Domain), intent (IN) :: Tdomain

integer :: i, j, ki, kj, n,ngllx, ngllz, idef0, idef1,mat, ierr
real :: dx,dxmin, courant, courant_max

courant_max = 0
do n = 0, Tdomain%n_elem - 1
     dxmin = 1e10
     ngllx =  Tdomain%specel(n)%ngllx
     ngllz =  Tdomain%specel(n)%ngllz
     do j = 0, ngllz -1
         do i = 0, ngllx-1
             idef0 = Tdomain%specel(n)%Iglobnum(i,j)
	     if (i < ngllx-1) then
   	        do ki = i+1, ngllx-1
                       idef1 = Tdomain%specel(n)%Iglobnum(ki,j)
		      dx = (Tdomain%Globcoord(0,idef0) - Tdomain%Globcoord(0,idef1))**2 + &
                                   (Tdomain%Globcoord(1,idef0) - Tdomain%Globcoord(1,idef1))**2
		      if (dx < dxmin ) dxmin = dx
		 enddo
	     endif
	     if (j < ngllz-1) then
         	     do kj  = j+1, ngllz-1
	                 do ki  = 0, ngllx-1
			     idef1 = Tdomain%specel(n)%Iglobnum(ki,kj)
		             dx = (Tdomain%Globcoord(0,idef0) - Tdomain%Globcoord(0,idef1))**2 + &
                                             (Tdomain%Globcoord(1,idef0) - Tdomain%Globcoord(1,idef1))**2
		              if (dx < dxmin ) dxmin = dx
			  enddo
		     enddo
             endif
        enddo
    enddo
    dxmin = sqrt (dxmin)
    mat = Tdomain%specel(n)%mat_index
    courant = (Tdomain%sSubdomain(mat)%Pspeed * Tdomain%sSubdomain(mat)%Dt)/ dxmin
    if (courant > courant_max ) courant_max = courant
enddo

call MPI_AllReduce (courant_max, courant, 1, MPI_DOUBLE_PRECISION, MPI_MAX, MPI_COMM_WORLD, ierr)

if (Tdomain%Mpi_Var%my_rank == 0 ) write (*,*) " The Courant number in your simulation is   ", courant
if (courant > 0.5 .and. courant < 1) then
   if (Tdomain%Mpi_Var%my_rank == 0 ) write (*,*) " Warning: you have a Courant larger than 0.5: dispersion can be high! "
else if (courant > 1 ) then
   if (Tdomain%Mpi_Var%my_rank == 0 ) write (*,*) "  You have a Courant larger than 1, the time scheme is unstable "
   if (Tdomain%Mpi_Var%my_rank == 0 ) write (*,*) " Change your time step dt! "
   stop
endif

return
end subroutine Compute_Courant 
