subroutine plot_grid (Tdomain)
use sdomain

implicit none
type(domain), target, intent (IN) :: Tdomain
integer :: n,i,i_aus,j, i_proc
real :: x0,z0
character (len=20) :: fnamef

! Plotting the grid

i_proc = Tdomain%Mpi_var%my_rank
write (fnamef, "(a,I2.2)") "grid.gnu.",i_proc
open (22,file=fnamef,form="formatted",status="unknown")
write (22,"(a2)") ">>"
do n = 0,Tdomain%n_elem-1
  do i = 0,3
     i_aus = Tdomain%specel(n)%Control_Nodes(i)
     x0 = Tdomain%Coord_Nodes(0,i_aus)
     z0 = Tdomain%Coord_Nodes(1,i_aus)
     write (22,*) x0, z0
 enddo
 write (22,"(a2)") ">>"
enddo
close (22)

if (Tdomain%logicD%super_object_local_present) then
   write (fnamef, "(a,I2.2)") "surface.gnu.",i_proc
   open (23,file=fnamef, form="formatted",status="unknown")
   write (23,"(a2)") ">>"
   do n = 0, Tdomain%n_fault-1
      do i = 0, Tdomain%sFault(n)%n_face-1
        do j = 0,1
           x0 = Tdomain%sFault(n)%Fface(i)%X_Vertex(j)
           z0 = Tdomain%sFault(n)%Fface(i)%Z_Vertex(j)
           write (23,*) x0, z0
        enddo
        write (23,"(a2)") ">>"
      enddo
   enddo
endif
close (23)
return
end subroutine plot_grid
