subroutine savefield (Tdomain,it)

use sdomain

implicit none

type (domain), intent (IN):: TDomain
integer, intent (IN) :: it

! local variables
integer :: ngllx,ngllz,ipoint, i,j,n_face,n, n_vertex
real :: dum1
real, dimension (0:1,0:Tdomain%n_glob_points-1) :: Field 
character (len=20) :: fnamef

Field = -2e6
do n = 0,Tdomain%n_elem-1
    ngllx = Tdomain%specel(n)%ngllx;  ngllz = Tdomain%specel(n)%ngllz
  
        do j = 1,ngllz-2
          do i = 1,ngllx-2
               ipoint = Tdomain%specel(n)%Iglobnum(i,j)
               Field (0,ipoint) = Tdomain%specel(n)%Veloc(i,j,0)
               Field (1,ipoint) = Tdomain%specel(n)%Veloc(i,j,1)
           enddo
        enddo
      
! Face 0 
   do i = 1, ngllx-2
     n_face = Tdomain%specel(n)%Near_face(0)
     if (Tdomain%sface(n_face)%Near_Element(0) == n) then
        ipoint = Tdomain%specel(n)%Iglobnum(i,0)
         Field (0,ipoint) = Tdomain%sFace(n_face)%Veloc(i,0)
         Field (1,ipoint) = Tdomain%sFace(n_face)%Veloc(i,1)
     endif
     n_face = Tdomain%specel(n)%Near_face(2)
     if (Tdomain%sface(n_face)%Near_Element(0) == n) then
         ipoint = Tdomain%specel(n)%Iglobnum(i,ngllz-1)
         Field (0,ipoint) = Tdomain%sFace(n_face)%Veloc(i,0)
         Field (1,ipoint) = Tdomain%sFace(n_face)%Veloc(i,1)
     endif
  enddo
  do j = 1, ngllz-2
     n_face = Tdomain%specel(n)%Near_face(1)
     if (Tdomain%sface(n_face)%Near_Element(0) == n) then
         ipoint = Tdomain%specel(n)%Iglobnum(ngllx-1,j)
         Field (0,ipoint) = Tdomain%sFace(n_face)%Veloc(j,0)
         Field (1,ipoint) = Tdomain%sFace(n_face)%Veloc(j,1)
     endif 
     n_face = Tdomain%specel(n)%Near_face(3)
     if (Tdomain%sface(n_face)%Near_Element(0) == n) then
         ipoint = Tdomain%specel(n)%Iglobnum(0,j)
         Field (0,ipoint) = Tdomain%sFace(n_face)%Veloc(j,0)
         Field (1,ipoint) = Tdomain%sFace(n_face)%Veloc(j,1)
     endif
  enddo

  n_vertex = Tdomain%specel(n)%Near_Vertex(0)
  ipoint = Tdomain%specel(n)%Iglobnum(0,0)
  Field (0,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(0)
  Field (1,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(1)
  
  n_vertex = Tdomain%specel(n)%Near_Vertex(1)
  ipoint = Tdomain%specel(n)%Iglobnum(ngllx-1,0)
  Field (0,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(0)
  Field (1,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(1)  
  
  n_vertex = Tdomain%specel(n)%Near_Vertex(2)
  ipoint = Tdomain%specel(n)%Iglobnum(ngllx-1,ngllz-1)
  Field (0,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(0)
  Field (1,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(1)  
  
  n_vertex = Tdomain%specel(n)%Near_Vertex(3)
  ipoint = Tdomain%specel(n)%Iglobnum(0,ngllz-1)
  Field (0,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(0)
  Field (1,ipoint) = Tdomain%sVertex(n_vertex)%Veloc(1)  
enddo

do n = 0, Tdomain%n_glob_points-1
   if (abs(Field(0,n)) < 1e-40) Field(0,n) = 0.
   if (abs(Field(1,n)) < 1e-40) Field(1,n) = 0.
enddo
! Dump field

dum1 = maxval (Field)
write(fnamef,"(a,I2.2,a1,I5.5)")"fieldt",Tdomain%mpi_var%my_rank, ".", (it+1)/10
open (61,file=fnamef,status="unknown",form="formatted")
do ipoint=0,Tdomain%n_glob_points-1
  if (.not. Field(0,ipoint) < -1e6 ) &
  write (61,"(3G17.8)") Tdomain%GlobCoord (0,ipoint), Tdomain%GlobCoord (1,ipoint), Field (0,ipoint)**2+Field (1,ipoint)**2
enddo  
call flush(61)
close(61)

return
end subroutine
