subroutine verify_in_quad (xc,yc,x,y,inner)
implicit none

! ##############################
! From mathforum
! Formula for a point in a rectangle within proof
!
! Gaetano Festa, modified 16/10/2004
! ############################# 

real, dimension (0:3), intent (IN) :: xc,yc
real, intent (IN) :: x,y
logical, intent (OUT) :: inner
real :: signA,signA0,A

inner = .false.
call two_area(xc(0),yc(0),xc(1),yc(1),x,y,A)
if (A /= 0)  then
    signA0 = A/abs(A)
    call two_area(xc(1),yc(1),xc(2),yc(2),x,y,A)
    if (A /= 0 ) then
       signA=signA0 * A/abs(A)
       if (signA < 0 ) return
    endif
else
    call two_area(xc(1),yc(1),xc(2),yc(2),x,y,A)
    if (A==0) inner = .true.
    signA0 = A/abs(A)
endif 
call two_area(xc(2),yc(2),xc(3),yc(3),x,y,A)
   if (A /= 0 ) then
       signA=signA0 * A/abs(A)
       if (signA < 0 ) return
  endif
call two_area(xc(3),yc(3),xc(0),yc(0),x,y,A)
   if (A /= 0 ) then
      signA=signA0 * A/abs(A)
      if (signA < 0 ) return
    endif
inner = .true.
return
end subroutine verify_in_quad

! ################################################################
subroutine two_area (x1,y1,x2,y2,x3,y3,A)
implicit none
real, intent (IN) :: x1,y1,x2,y2,x3,y3
real, intent (OUT) :: A

A = x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2)
return
end subroutine two_area
