# Plotting shell for the fields
echo 'Do you want plot the surfaces ?(yes or no)'
set answer=($<)
if ($answer == yes) then
  rm -rf surface.gnu
  cat surface.gnu.* >> surface.gnu
endif

# Define a palette of color 
echo ' Do you want to use makecpt for generating the palette ? (yes/no)'
set sec_answer=($<)
if ($sec_answer == yes) then
   echo 'To use makecpt you have to specify...'
   echo '(a) The palette color'
   set palette=($<)
   echo '(b) The minimum , the maximum value, the interval of the palette '
   set pm=($<)
   set pM=($<)
   set pin=($<)
   makecpt -C$palette -Z -T$pm/$pM/$pin  > pala.cpt
else
    echo ' The palette should be in the file pala.cpt'
endif
echo
echo 'Do you want to plot  .....'
echo 'The epsilon_plus (1)  '
echo ' The epsilon_minus (2)'
echo ' The epsi_point (3)'
set sec_answer=($<)

if ($sec_answer == 1) then
   ls epsilon_plus00.* > index
   sed 's/epsilon_plus00./epsilon_plus /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
   set output="epsilon_plus."
else if ($sec_answer == 2) then
   ls epsilon_minus00.* > index
   sed 's/epsilon_minus00./epsilon_minus /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
   set output="epsilon_minus."
else
   ls epsi_point00.* > index
   sed 's/epsi_point00./epsi_point /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
   set output="epsi_point."
endif

set orig = `sed q index`
set orig_2 = "*"$orig
ls $orig_2 > index_aus
set n_proc = `sed -n '$=' index_aus`
echo "The number of processors is " $n_proc 


if ($sec_answer == 1) then
   set orig = "epsilon_plus"
else if ($sec_answer == 2) then
   set orig = "epsilon_minus"
else
   set orig = "epsi_point"
endif

echo
echo 'Define the minimum and the maximum field values....'
set pm=($<)
set pM=($<)
echo
echo 'To use surface and plot commands you should introduce ... '
echo '(a) The interval of sampling (-I)'
set iv=($<)
echo '(b) The minimum, maximum values for both x and z directions (-R)'
set rm=($<)
set rM=($<)
set Rm=($<)
set RM=($<)
echo '(c) The dimensions of the picture (-JX) '
set jxm=($<)
set jxM=($<)

set i = $pm
while ($i<$pM)
  set ip = $i"p"
  set fin = `sed -n $ip index`
  set data_fin = "*"$fin
  set data_2 = $orig"."
  set data2_fin = $data_2$fin
  cat $data_fin >> squezz
  mv -f squezz $data2_fin
  rm -f squeez
  set fing = $data2_fin".grd"
  set fina = $data2_fin".ps"
  set finxyz = $data2_fin".xyz"
  set finepsi = $data2_fin".epsi"
  set fingif =  $data2_fin".gif"


  surface  $data2_fin -G$fing -I$iv -R$rm/$rM/$Rm/$RM -V -T1
  if ($answer == 'yes') then
    grdimage $fing -Cpala.cpt -JX$jxm/$jxM -R -V -K -P > $fina
    psxy surface.gnu -JX -R -M -W1.5p/255/255/255 -O >> $fina
  else
    grdimage $fing -Cpala.cpt -JX$jxm/$jxM -R -V -P -B > $fina
  endif

  setenv LANG C; ps2epsi $fina
  convert $finepsi $fingif
  rm -f $data2_fin

@ i++
end
echo 
echo 'Do you want erase epsi files?(yes or no)'
set answer=($<)
rm -f *grd *ps 
if ($answer == 'yes') then
    rm -f *epsi
endif
set final_file=$output"movie.gif"
rm -f $final_file
convert -delay 50 -loop 1000 -colors 256 $output"*.gif" $final_file
mozilla-firefox $final_file
exit 0
