program gid2spec_parallel
implicit none

logical :: logic_1, logic_2, super_object_present, super_object_locally_present
logical, dimension (:), allocatable :: Which_points_inside, Which_vertices_external,Logic_proc_count
logical, dimension (:,:,:), allocatable ::  Face_Coherency

integer, parameter :: N_MAX_POINTS = 10000
integer :: ndim_space, nglob_ctlpt, n_mat, n_elem, n_nods, n_line, n_vertex_on_interface, idummy
integer :: i, j, n, ndim_stor, ndim_out, edgecut, n_proc, i_proc, n_elem_local, n_glob_point_local
integer :: k, j1, j2, k1, k2, nn, n_vertex, n_faces, k_proc
integer :: n_MAX_faces, n_MAX_vertex, n_MAX_Face_to_Comm, n_MAX_Vertex_to_Comm
integer, external :: max_value
integer, dimension (:), allocatable :: Elements, npart, epart, Global_to_local, Vertex_to_glob, N_Valid_Vertex
integer, dimension (:), allocatable :: N_ExtFaces, N_ExtVertices, n_proc_effective, Elem_to_LocalElem
integer, dimension (:,:), allocatable :: Ipointer, Ipointer_local, Build_Faces, El_to_Face, El_to_Vertex, Face_to_El
integer, dimension (:,:), allocatable :: Face_to_Vertex, Face_to_El_What, Tell_me_ExtFaces,Index_1,Index_2
integer, dimension (:,:), allocatable :: Tell_me_ExtVertices, ExtVertices_to_Glob,  Communication_table
integer, dimension (:,:,:), allocatable :: ExtFaces_to_Glob_Vertices, Face_to_Comm, Vertex_to_Comm

real, dimension (:,:), allocatable :: Gcoord, Gcoord_local
character (len=10) :: answer
character (len=20) :: fnamef
character (len=40) :: gnameg

! Super Object variables
logical , dimension (:), allocatable :: No_Elements_on_face, Local_So_vertex
logical, dimension (:,:), allocatable :: Super_Object, Super_Object_Local

integer :: low_material, up_material, n_so_vertices, n_faces_super_object	
integer, dimension (1:N_MAX_POINTS) :: Aus_int
integer, dimension (:), allocatable :: Super_Object_Coherency
integer, dimension (:,:), allocatable :: Super_Object_to_Face,Super_Object_Vertex, Super_Object_Face_to_Vertex
integer, dimension (:,:), allocatable :: Nodes_on_boundary, Super_Object_Which_Face
integer, dimension (:,:), allocatable :: Super_Object_UP_Face_to_Vertex, Super_Object_DOWN_Face_to_Vertex
integer, dimension (:,:), allocatable :: Super_Object_Which_Face_local, Vertex_of_superObject
integer, dimension (:,:), allocatable :: Index_3
integer, dimension (:,:,:), allocatable :: SuperObject_Vertex_to_Comm

real, parameter :: tolerance = 1e-3
real :: dist
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! This Program reads a GID output file and translates  
! it into an input file for 2DSPEC for parallel computation
! It makes use of METIS for domain decomposition
! It allows for super object to be analyzed 			   
! For this aim the initial super-object is just a fault
!		
! Gaetano Festa, last modification 06/10/2005	
! The parameter variable N_MAX_POINTS is connected to the maximum length of the 
! input boundary file
!   
!							   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Asking for the input files: a super object must have vertices declared 
! in a different file

write (*,*) " Do you have any super-object, defined through a file ? (y/n)"
read (*,*) answer
super_object_present = .false.
super_object_locally_present = .false.
if (answer == "y") super_object_present = .true.
if (super_object_present) then
   write (*,*) " Introduce the name of the Boundary name"
   read (*,*) fnamef
   open (12,file=fnamef,status="old")
   n_vertex_on_interface = 0
   do i = 1,N_MAX_POINTS
      read (12,*, end=80) Aus_int (i)
      n_vertex_on_interface  = n_vertex_on_interface  + 1
   enddo
80 close(12) 
 
   write (*,*) "Number of points on the super_object interface", n_vertex_on_interface
   allocate (Nodes_on_Boundary(0:n_vertex_on_interface -1,0:1))
   Nodes_on_Boundary (0:n_vertex_on_interface -1,0) = Aus_int(1:n_vertex_on_interface) - 1
else
   n_vertex_on_interface = 0
endif

write (*,*) " Introduce the name of the GID file"
read (*,*) fnamef

open (11,file=fnamef,status="old")
read (11,*)                 ! Name of the mesh
read (11,*)    ndim_space   ! Dimension
read (11,*)                 ! Element Type
read (11,*)    n_nods       ! Number of control points for each element
read (11,*)    nglob_ctlpt  ! Number of points
read (11,*)    n_elem       ! Number of elements
read (11,*)    n_mat        ! Number of materials

write(*,*) 'Number of Points, Elements, Material:',nglob_ctlpt, n_elem, n_mat
n_line = 1


read (11,*)
read (11,*)  ! Begin to read Coordinates
allocate (Gcoord (0:ndim_space-1,0:nglob_ctlpt-1+n_vertex_on_interface))

do i = 0,nglob_ctlpt-1
   read (11,*)  idummy,(Gcoord(j,i),j=0,ndim_space-1)
enddo
!!!! Abusivo
!Gcoord = 2* Gcoord
!!! Abusivo
read (11,*)  ! end coordinates
read (11,*)

read (11,*)  ! Begin to read Elements
ndim_stor = n_nods+1

if ( ndim_space ==2 ) then
   ndim_out = ndim_stor + 8
else
   write(*,*) "Warning 3D"
endif 
allocate (Ipointer(0:ndim_out-1,0:n_elem-1))

do n = 0,n_elem-1
    read (11,*)  idummy,(Ipointer(j,n),j=0,ndim_stor-1)
enddo
read (11,*)  ! endElements

close (11)

! If a super-obeject is present the number of points should be incremented 
idummy = nglob_ctlpt
do i = 0, n_vertex_on_interface-1 
 Nodes_on_Boundary(i,1) = idummy
 Gcoord(:,nglob_ctlpt+i) = Gcoord(:,Nodes_on_boundary(i,0))
 idummy = idummy + 1
enddo
nglob_ctlpt = idummy
if (super_object_present) write (*,*), "Because of doubling, total number of points changed to   ",nglob_ctlpt

! Change the numbering of elements

do n = 0,n_elem-1
   if (n_nods == 4) then
     do j = 0,3
       Ipointer(j,n) = Ipointer (j,n) - 1
     enddo
   else if (n_nods == 8) then
     do j = 0,7
       Ipointer(j,n) = Ipointer (j,n) - 1
     enddo
   endif
enddo

! Rotate elements 
call rotate (Ipointer,Gcoord,ndim_out,n_elem,nglob_ctlpt,n_nods,4)

! To constrain a super_object we need to know the two interfaces separating the object
! they can have the same properties but they need to have different indices

! Putting the elements in the form required by METIS
write (*,*) "Introduce the number of processors"
read (*,*) n_proc 

allocate (Elements(0:4*n_elem-1))
do n = 0, n_elem -1
  do i= 0,3
    idummy = n*4 +i 
    Elements(idummy) = Ipointer(i,n)
  enddo
enddo

allocate (epart(0:n_elem-1))
allocate (npart(0:nglob_ctlpt-1))

! call METIS
write (*,*) "Entering METIS computation"
call METIS_PartMeshDual(n_elem, nglob_ctlpt, Elements, 4, 0,n_proc, edgecut, epart, npart)
write (*,*) " Partition done by METIS" 

if (super_object_present) then
  allocate (Super_Object(0:1,0:n_elem-1)); allocate (Super_Object_Which_Face(0:1,0:n_elem-1))
  Super_Object = .false.;   Super_Object_Which_Face = -1

  write (*,*) "introduce low_material and up_material indices"
  read(*,*) low_material, up_material
  do n = 0, n_elem -1 
    if (Ipointer ( ndim_stor-1,n)== low_material) then
      do j = 0,3
          j1 = Ipointer(j,n)
          j2 = Ipointer(j+1,n)
          if (j == 3) j2 = Ipointer(0,n)
          logic_1 = .false.
          do_nn_back01 : do nn = 0,n_elem-1
	    if (Ipointer(ndim_stor-1,nn) == up_material ) then
             do k = 0,3
                 k1 = Ipointer(k,nn)
                 k2 = Ipointer(k+1,nn)
                 if (k == 3) k2 = Ipointer(0,nn)
                 if (k1 == j1 .and. k2 == j2 ) logic_1 = .true.  
                 if (k1 == j2 .and. k2 == j1 ) logic_1 = .true.  
                 if (logic_1 ) then
		 	    Super_Object(1,n) = .true.
			    Super_Object(0,nn) = .true.
			    Super_Object_Which_Face (0,n) = j
	       	            Super_Object_Which_Face (0,nn) = k
			    Super_Object_Which_Face (1,nn) = n
			    if (epart(n) /= epart(nn)) epart(n) = epart (nn)
                            exit do_nn_back01
                 endif
	     enddo
	   endif
          enddo do_nn_back01
     enddo
   endif
  enddo
! Change indices on the lower interface
  do n = 0, n_elem-1
    if (Ipointer ( ndim_stor-1,n)== low_material) then
      do k = 0,3
          do_nn_interior : do  nn = 0, n_vertex_on_interface -1 
	     if (Ipointer (k,n) == Nodes_on_boundary(nn,0)) then
	           Ipointer (k,n) = Nodes_on_boundary(nn,1)
		   exit do_nn_interior
	     endif
	  enddo do_nn_interior
      enddo
    endif
  enddo
endif 

! Routine used to plot the mesh
write (*,*) " Do you want to plot the mesh ? (yes/not) "
read (*,*) answer
if (answer == "yes" ) then
  do i =0, n_proc-1
    write (fnamef, "(a16,i2.2)") "mesh4plot.input.",i+1
    open (22,file=fnamef)
    do n= 0, n_elem-1
        if (epart(n) == i) then
              do j = 0,3
                idummy = Ipointer (j,n)
	        write (22,*) Gcoord(0:1,idummy)
	      enddo  
	      write (22,"(a2)") ">>"
        endif
    enddo
    close (22)
  enddo
endif

! Compute local files
allocate (Which_points_inside(0:nglob_ctlpt-1))
allocate (Tell_me_ExtFaces(0:8*n_elem/n_proc-1,0:n_proc-1))
allocate (Tell_me_ExtVertices(0:8*n_elem/n_proc-1,0:n_proc-1))
allocate (Global_to_local (0:nglob_ctlpt-1))
allocate (ExtFaces_to_Glob_Vertices(0:1,0:8*n_elem/n_proc-1,0:n_proc-1))
allocate (ExtVertices_to_Glob(0:8*n_elem/n_proc-1,0:n_proc-1))
allocate (N_ExtFaces(0:n_proc-1))
allocate (N_ExtVertices(0:n_proc-1))
allocate (Elem_to_LocalElem(0:n_elem-1))
if (super_object_present ) then
   allocate (Vertex_of_Superobject(0:n_vertex_on_interface-1,0:n_proc-1))
   Vertex_of_SuperObject = -1
endif

ExtFaces_to_Glob_Vertices = -1
Tell_me_ExtFaces = -1

do i_proc = 0, n_proc-1
  Elem_to_LocalElem = -1
  Which_points_inside = .false.
! Count how many nodes and elements are inside the domain
   n_elem_local = 0
   n_glob_point_local = 0 
   do n = 0, n_elem-1
      if (epart(n) == i_proc ) then
      	 Elem_to_LocalElem (n) = n_elem_local
         n_elem_local = n_elem_local +1
	 if (n_nods == 4) then 
	   do i = 0,3
	      idummy = Ipointer (i,n)
	      Which_points_inside (idummy) =.true.
	   enddo
	 else if (n_nods ==8 ) then
	   do i = 0,7
	      idummy = Ipointer (i,n)
	      Which_points_inside (idummy) =.true.
	   enddo	 
	 else
	  write (*,*) "n_nods is different from 4/8"
	  stop   
         endif
      endif
   enddo
   Global_to_local = -1
   do n = 0, nglob_ctlpt -1 
     if (Which_points_inside(n)) then
            Global_to_local (n) = n_glob_point_local
            n_glob_point_local = n_glob_point_local + 1 
     endif	    
   enddo      
   allocate (Gcoord_local(0:1, 0:n_glob_point_local-1))
   do n = 0, nglob_ctlpt -1 
         if (Which_points_inside(n)) then
	    idummy = Global_to_local (n)
	    Gcoord_local (0:1, idummy) = Gcoord (0:1,n)
         endif
   enddo
   allocate (Ipointer_local (0:ndim_out-1,0:n_elem_local-1))
   j = 0
   do n = 0, n_elem - 1
      if (epart (n) == i_proc) then   
          Ipointer_local (0:ndim_out-1,j) = Ipointer (0:ndim_out-1,n)
	  if (n_nods == 4) then 
	     do i = 0,3
	        idummy = Ipointer (i,n)
                Ipointer_local(i,j) = Global_to_local(idummy)
             enddo
	   else if (n_nods ==8 ) then
	     do i = 0,7
	        idummy = Ipointer (i,n)
                Ipointer_local(i,j) = Global_to_local(idummy)
	     enddo	 
	   endif
           j= j + 1
       endif
   enddo
  
! Now the strcuture of the interior of any domain should be performed in the same way as previously
! Chose the effective vertices among the control nodes
   n_MAX_Vertex = 4 * n_elem_local
   allocate (Vertex_to_Glob(0:n_MAX_Vertex-1))
   allocate (N_valid_Vertex(0:n_glob_point_local-1))
   N_valid_Vertex = -1

   allocate (El_to_Vertex(0:3,0:n_elem_local-1))

   n_vertex = 0
   do n = 0,n_elem_local - 1
     do j = 0,3
        idummy = Ipointer_local(j,n)
        if (N_valid_Vertex(idummy) < 0) then 
            N_valid_Vertex(idummy) = n_vertex
	    El_to_Vertex(j,n) = n_vertex
            Vertex_to_Glob(n_vertex) = idummy
            n_vertex = n_vertex + 1
        else
          El_to_Vertex(j,n) = N_Valid_Vertex(idummy)	  
        endif
     enddo
  enddo
    
! Define faces properties 
  n_MAX_faces = 4 * n_elem_local
  allocate (El_to_face(0:3,0:n_elem_local-1))
  allocate (Face_to_El(0:1,0:n_MAX_faces-1))
  allocate (Face_to_El_What(0:1,0:n_MAX_faces-1))
  allocate (Face_to_Vertex(0:1,0:n_MAX_faces-1))

  Face_to_El = -1; Face_to_El_What = -1;
  n_faces = 0
  do n = 0, n_elem_local-1
     do j = 0,3
        j1 = Ipointer_local(j,n)
        j2 = Ipointer_local(j+1,n)
        if (j == 3) j2 = Ipointer_local(0,n)

        logic_1 = .false.
        do_nn_back1 : do nn = 0,n-1
           do k = 0,3
               k1 = Ipointer_local(k,nn)
               k2 = Ipointer_local(k+1,nn)
               if (k == 3) k2 = Ipointer_local(0,nn)
               if (k1 == j1 .and. k2 == j2 ) logic_1 = .true.  
               if (k1 == j2 .and. k2 == j1 ) logic_1 = .true.  
                        if (logic_1 ) then
                            El_to_face (j,n) = El_to_face (k,nn)
                            Face_to_el (1,El_to_face (k,nn) ) = n
                            Face_to_el_What (1,El_to_face (k,nn) ) = j
                            exit do_nn_back1
                        endif

           enddo
        enddo do_nn_back1
        if (.not. logic_1) then
           El_to_face (j,n) = n_faces
           Face_to_el (0,n_faces ) = n
           Face_to_el_What (0,n_faces ) = j
           Face_to_Vertex (0,n_faces) = N_valid_Vertex(j1)
           Face_to_Vertex (1,n_faces) = N_valid_Vertex(j2)
           n_faces = n_faces + 1
        endif
     enddo
  enddo
  
  do n = 0, n_elem_local-1
    if (n_nods == 4 ) then
        Ipointer_local (12,n) = Ipointer_local (ndim_stor-1,n) - 1
        Ipointer_local (4:7,n) = El_to_face (0:3,n)
	Ipointer_local (8:11,n) = El_to_Vertex(0:3,n)
    else if (n_nods == 8 ) then 
        Ipointer_local (16,n) = Ipointer_local (ndim_stor-1,n) -1
        Ipointer_local (8:11,n) = El_to_face (0:3,n)
	Ipointer_local(12:15,n) = El_to_Vertex(0:3,n)
    endif 
  enddo

  write(*,*) "Number of elements, faces and vertices inside the proc",i_proc, " are: ", n_elem_local, n_faces, n_vertex
  allocate (Build_faces(0:5,0:n_faces-1))
  do n = 0, n_faces - 1
    Build_faces (0:1,n) = Face_to_el (0:1, n)
    Build_faces (2:3,n) = Face_to_el_What (0:1, n)
    Build_faces (4:5,n) = Face_to_Vertex (0:1, n)
  enddo

  ! Define the ordering of faces
  do n = 0, n_faces - 1
    nn = Build_Faces(0,n)
    k = Build_Faces(2,n)
    if (k == 0 .and. Vertex_to_Glob(Build_Faces(4,n)) == Ipointer_local(1,nn) ) then
              k1 = Build_Faces(4,n); Build_Faces(4,n) =  Build_Faces(5,n); Build_Faces(5,n)= k1
    else if (k == 1 .and. Vertex_to_Glob(Build_Faces(4,n)) == Ipointer_local(2,nn) ) then
              k1 = Build_Faces(4,n); Build_Faces(4,n) =  Build_Faces(5,n); Build_Faces(5,n)= k1
    else if (k == 2 .and. Vertex_to_Glob(Build_Faces(4,n)) == Ipointer_local(2,nn) ) then
              k1 = Build_Faces(4,n); Build_Faces(4,n) =  Build_Faces(5,n); Build_Faces(5,n)= k1
    else if (k == 3 .and. Vertex_to_Glob(Build_Faces(4,n)) == Ipointer_local(3,nn) ) then
              k1 = Build_Faces(4,n); Build_Faces(4,n) =  Build_Faces(5,n); Build_Faces(5,n)= k1
    endif
  enddo
  
! Define super Object properties
! Count n_faces_super_object
  if (super_object_present) then
    allocate (Super_Object_Local (0:1,0:n_elem_local-1))
    allocate (Super_Object_Which_Face_Local(0:1,0:n_elem_local-1))
    Super_Object_Local =.false.
    Super_Object_Which_Face_Local = -1
    super_object_locally_present = .false.
    do n = 0, n_elem-1
       logic_1 = Super_Object (0,n) .or. Super_Object(1,n)
       if (epart(n) == i_proc .and. logic_1) then
           i = Elem_to_LocalElem(n)
           Super_Object_local(0:1,i) = Super_Object(0:1,n)
	   Super_Object_Which_Face_Local (0,i) = Super_Object_Which_Face (0,n)
	   nn = Super_Object_Which_Face(1,n)
	   super_object_locally_present = .true.
	   if (nn> -1) then
	       if (Elem_to_LocalElem (nn) > -1) then
    	         Super_Object_Which_Face_local (1,i) = Elem_to_LocalElem(nn)
	       else
	         write (*,*) "Error in the element definition around the fault"
	       endif
	   endif
       endif
   enddo

   if (super_object_locally_present) then
     n_faces_super_object = 0 
     do n = 0, n_elem_local -1
        if (Super_Object_Local(0,n)) n_faces_super_object = n_faces_super_object + 1
     enddo
     write (*,*) "Number of faces in the super object for the processor ", i_proc," is:  ", n_faces_super_object
     idummy = 0
     allocate (Super_Object_to_Face (0:1, 0:n_faces_super_object-1))
     allocate (Super_Object_Coherency(0:n_faces_super_object-1))
     Super_Object_to_Face = -1
     do n = 0, n_elem_local -1
      if (Super_Object_Local(0,n)) then
         k = Super_Object_Which_Face_Local(0,n)
         Super_Object_to_Face(0,idummy) = El_to_Face(k,n)
	 nn = Super_Object_Which_Face_Local(1,n)
	 k = Super_Object_Which_Face_Local(0,nn)
	 Super_Object_to_Face(1,idummy) = El_to_Face(k,nn)
	 Super_Object_Local(1,nn) = .false.
	 idummy = idummy + 1
      endif
    enddo   
    if (idummy /= n_faces_super_object) then
        write (*,*) "There is a problem in counting super object faces"
	stop
    endif
    if (n_faces_super_object > 0) then
      allocate (Super_Object_UP_Face_to_Vertex (0:1,0:n_faces_super_object-1))
      allocate (Super_Object_DOWN_Face_to_Vertex (0:1,0:n_faces_super_object-1))
      allocate (Super_Object_Face_to_Vertex(0:1,0:n_faces_super_object-1))
    endif
    do n = 0, n_faces_super_object-1
         k = Super_Object_to_Face(0,n)
	 Super_Object_UP_Face_to_Vertex (0:1,n) = Build_Faces(4:5,k)
	 k = Super_Object_to_Face(1,n)
  	 Super_Object_DOWN_Face_to_Vertex (0:1,n) = Build_Faces(4:5,k)
	 
	 k1 = Super_Object_UP_Face_to_Vertex (0,n)
	 k2 = Super_Object_UP_Face_to_Vertex (1,n)
	 j1 = Super_Object_DOWN_Face_to_Vertex (0,n)
	 j2 = Super_Object_DOWN_Face_to_Vertex (1,n)
  	 logic_1 = .false.; logic_2 = .false.
	 if (k1 == j1 .or. k1 == j2) logic_1 = .true.
	 if (k2 == j2 .or.  k2 == j1) logic_2 = .true.
	 if (logic_1) then    ! Termination on k1
	     if (k1 == j1) then
	        Super_Object_Coherency(n) = 1 
	     else
	        Super_Object_Coherency(n) = 0
  	     endif
	 else if (logic_2) then  ! Termination on k2
	     if (k2 == j2) then
	        Super_Object_Coherency(n) = 1 
	     else
	        Super_Object_Coherency(n) = 0
  	     endif
	 else 
	     Super_Object_Coherency(n) = -1
	     j = Vertex_to_Glob(j1)
	     k = Vertex_to_Glob(k1)
	     dist = (Gcoord_local (0,j) - Gcoord_local (0,k))**2 + (Gcoord_local (1,j) - Gcoord_local (1,k))**2
	     if (dist < tolerance ) Super_Object_Coherency (n) = 1
	     j = Vertex_to_Glob (j2)
	     dist = (Gcoord_local (0,j) - Gcoord_local (0,k))**2 + (Gcoord_local (1,j) - Gcoord_local (1,k))**2
	     if (dist < tolerance ) Super_Object_Coherency (n) = 0 
	     if (super_object_coherency(n) == -1) then
	          write (*,*) "There is a problem in defining the coherency"
	          stop
	     endif
	 endif
    enddo
    
    allocate (Local_So_vertex(0:n_vertex-1))
    Local_So_Vertex = .false.
    n_so_vertices = 0
    do n = 0, n_faces_super_object - 1
       k1 = Super_Object_UP_Face_to_Vertex (0,n)
       if (.not. Local_So_Vertex (k1)) then
           Local_So_Vertex(k1) = .true.
	   Super_Object_Face_to_Vertex (0,n) = n_so_vertices
	   n_so_vertices = n_so_vertices + 1
       else
           do_interior1 : do nn = 0, n-1
	      j1 = Super_Object_UP_Face_to_Vertex (0,nn)
	      j2 = Super_Object_UP_Face_to_Vertex (1,nn)
	      if (j1 == k1) then
	         Super_Object_Face_to_Vertex (0,n) = Super_Object_Face_to_Vertex(0,nn)
		 exit do_interior1
	      endif
	      if (j2 == k1) then
	         Super_Object_Face_to_Vertex (0,n) = Super_Object_Face_to_Vertex(1,nn)
		 exit do_interior1
	      endif
	   enddo do_interior1
       endif
       k1 = Super_Object_UP_Face_to_Vertex (1,n)
       if (.not. Local_So_Vertex (k1)) then
           Local_So_Vertex(k1) = .true.
	   Super_Object_Face_to_Vertex (1,n) = n_so_vertices
	   n_so_vertices = n_so_vertices + 1
       else
           do_interior2 : do nn = 0, n-1
	      j1 = Super_Object_UP_Face_to_Vertex (0,nn)
	      j2 = Super_Object_UP_Face_to_Vertex (1,nn)
	      if (j1 == k1) then
	         Super_Object_Face_to_Vertex (1,n) = Super_Object_Face_to_Vertex(0,nn)
		 exit do_interior2
	      endif
	      if (j2 == k1) then
	         Super_Object_Face_to_Vertex (1,n) = Super_Object_Face_to_Vertex(1,nn)
		 exit do_interior2
	      endif
	   enddo do_interior2
       endif
    enddo

    if (n_so_vertices > 0) then
      allocate (Super_Object_Vertex(0:1, 0:n_so_vertices -1))
      Super_Object_Vertex = -1
      Local_So_Vertex = .false.
      idummy = 0.
      do n = 0, n_faces_super_object - 1
         k1 = Super_Object_UP_Face_to_Vertex (0,n)
         j1 = Super_Object_DOWN_Face_to_Vertex (0,n)
         if (.not. Local_So_Vertex (k1)) then
           Local_So_Vertex(k1) = .true.
	   if (k1 == j1 ) then
	      Super_Object_Vertex (0:1, idummy) = -3	      
	   else 
	      Super_Object_Vertex (0,idummy) = k1
	      Super_Object_Vertex (1,idummy) = j1
	   endif
	   idummy = idummy + 1
         endif
         k1 = Super_Object_UP_Face_to_Vertex (1,n)
         j1 = Super_Object_DOWN_Face_to_Vertex (1,n)
         if (.not. Local_So_Vertex (k1)) then
           Local_So_Vertex(k1) = .true.
	   if (k1 == j1 ) then
	      Super_Object_Vertex (0:1, idummy) = -3	      
	   else 
	      Super_Object_Vertex (0,idummy) = k1
	      Super_Object_Vertex (1,idummy) = j1
	   endif
	   idummy = idummy + 1
         endif
      enddo
     endif   
     Vertex_of_superobject (0:n_so_vertices-1,i_proc) = Super_Object_Vertex (0, 0:n_so_vertices-1) 
   endif
  endif
   
  idummy = 0
  allocate (Which_vertices_external(0:n_vertex-1))
  Which_vertices_external = .false.
  do n = 0, n_faces-1
     if (Build_Faces(1,n) == -1) then
       Tell_me_ExtFaces (idummy,i_proc) = n
       j2 = Build_Faces (4,n)
       Which_vertices_external (j2) = .true.
       j1 = Vertex_to_glob (j2)
       doj_here1 : do j = 0, nglob_ctlpt - 1
           if (j1 == Global_to_local(j)) exit doj_here1
       enddo doj_here1
       ExtFaces_to_Glob_Vertices (0,idummy, i_proc) =  j
       j2 = Build_Faces (5,n)
       Which_vertices_external (j2) = .true.
       j1 = Vertex_to_glob (j2)
       doj_here2 : do j = 0, nglob_ctlpt - 1
           if (j1 == Global_to_local(j)) exit doj_here2
       enddo doj_here2
       ExtFaces_to_Glob_Vertices (1,idummy, i_proc) =  j
       idummy = idummy + 1
    endif
  enddo
  N_ExtFaces (i_proc) = idummy
  write (*,*) "Number of inquiered faces for proc ", i_proc, " is" , idummy
  
! verification of external vertices
  idummy = 0
  do n = 0, n_vertex-1
     if (Which_vertices_external(n)) then
        j1 = Vertex_to_Glob (n)
	doj_here3 : do j = 0, nglob_ctlpt - 1
           if (j1 == Global_to_local(j)) exit doj_here3
        enddo doj_here3
        Tell_me_ExtVertices(idummy, i_proc) = n
	ExtVertices_to_Glob(idummy, i_proc) = j
        idummy=idummy+1
     endif
  enddo
  N_ExtVertices(i_proc) = idummy
  write (*,*) "Number of inquiered vertices for proc ", i_proc, " is" , idummy
  
! Write Local Output
  write (fnamef, "(a16,I2.2)") "mesh4spec.input.", i_proc
  open (12,file=fnamef,status="unknown",form="formatted")

  write (12,202)    ndim_space, " ! Space dimension "
  write (12,202)    n_glob_point_local, " ! Number of local nodes "

  do i = 0,n_glob_point_local-1
      write (12,201)  (Gcoord_Local(j,i),j=0,ndim_space-1)
  enddo

  write (12,202)  n_mat, " ! Number of materials "

  ! Artificially created

  write (12,202)  1, " ! Number of line "
  write (12,*) "Write the line number and name"
  write (12,202) 1,"L1"

  write (12,202)   n_elem_local, "! number of local elements"
  write (12,202)   n_nods, "! number of nodes"
  write (12,203)  "! For any element, listed the reference to the global list of elements, the faces, the material"
  do n = 0,n_elem_local - 1
     if (n_nods == 4 ) then
         write (12,204) (Ipointer_local(k,n),k=0,ndim_out-1)
     else if  (n_nods == 8 ) then
         write (12,205) (Ipointer_local(k,n),k=0,ndim_out-1)
     endif
  enddo
  write (12,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  write (12,202)   n_faces, "! number of faces"
  write (12,203)  "! For any face, listed to the elements, what face of the element and the vertices"
  do n = 0,n_faces-1
       write (12,206) (Build_faces(k,n),k=0,5)
  enddo
  write (12,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
  write (12,202)   n_vertex, "! number of vertices"
  write (12,203)  "! For any vertex, address to the global numbering"
  do n = 0,n_vertex-1
       write (12,*) Vertex_to_Glob(n)
  enddo
  if (super_object_present) then
    if (super_object_locally_present) then
      write (12,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      write (12,202)   0, "! Type of super-object, 0 fault, 1 Mortar"
      write (12,202)   n_faces_super_object , "Number of faces contained in the super-object"
      do n = 0, n_faces_super_object-1
         write (12,207)   Super_Object_to_Face(0:1,n), Super_Object_Face_to_Vertex(0:1,n), Super_Object_Coherency(n)
      enddo
      write (12,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      write (12,202)   n_so_vertices, "Number of vertices contained in the super-object"
      do n = 0, n_so_vertices -1 
         write (12,207)   Super_Object_Vertex(0:1,n)
      enddo
     else
      write (12,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
      write (12,202)   -1, "! No pieces of the object are present here"
     endif
  endif
  close (12)
  
  deallocate (Which_vertices_external)
  deallocate (Vertex_to_Glob)
  deallocate (N_Valid_Vertex)
  deallocate (El_to_Face)
  deallocate (Face_to_El)
  deallocate (Face_to_El_What)
  deallocate (Face_to_Vertex)
  deallocate (Build_faces)
  deallocate (Gcoord_local)
  deallocate (Ipointer_local)
  if (super_object_present) then
    if (super_object_locally_present) then
       deallocate (Super_Object_to_Face)
       deallocate (Super_Object_Coherency)
       if (n_faces_super_object > 0) then
         deallocate (Super_Object_UP_Face_to_Vertex)
         deallocate (Super_Object_DOWN_Face_to_Vertex)
	 deallocate (Super_Object_Face_to_Vertex)
       endif
       if (n_so_vertices > 0) deallocate (Super_Object_Vertex)
    endif
    deallocate (Super_Object_Local)
    deallocate (Super_Object_Which_Face_local)  
  endif
enddo

n_MAX_Face_to_Comm = max_value (N_ExtFaces,n_proc)
n_MAX_Vertex_to_Comm = max_value (N_ExtVertices, n_proc)
allocate (Face_to_Comm(0:n_MAX_Face_to_Comm-1,0:n_proc-1,0:n_proc-1))
allocate (Face_Coherency(0:n_MAX_Face_to_Comm-1,0:n_proc-1,0:n_proc-1))
allocate (Index_1(0:n_proc-1,0:n_proc-1))
allocate (Vertex_to_Comm(0:n_MAX_Vertex_to_Comm-1,0:n_proc-1,0:n_proc-1))
allocate (Index_2(0:n_proc-1,0:n_proc-1))
Index_1 = 0

do i_proc = 0, n_proc-1
 do i = 0, N_ExtFaces(i_proc)-1
    j1 = ExtFaces_to_Glob_Vertices(0,i,i_proc)
    j2 = ExtFaces_to_Glob_Vertices(1,i,i_proc)
    logic_1 = .false.; logic_2 = .true.
    do_ki : do k_proc =0, i_proc-1
       do k = 0, N_ExtFaces(k_proc)-1
         k1 = ExtFaces_to_Glob_Vertices(0,k,k_proc)
         k2 = ExtFaces_to_Glob_Vertices(1,k,k_proc)
         if (k1==j1 .and. k2==j2) logic_1 = .true.
	 if (k2==j1 .and. k1==j2) then
	         logic_1 = .true.
		 logic_2 = .false.
         endif
	 if (logic_1) then
	    Face_Coherency (Index_1 (i_proc,k_proc), i_proc, k_proc) = .true. 
	    if (logic_2) then
	         Face_Coherency (Index_1 (i_proc,k_proc), k_proc, i_proc) = .true.
            else 
                 Face_Coherency (Index_1 (i_proc,k_proc), k_proc, i_proc) = .false. 
	    endif
	    Face_to_Comm(Index_1(i_proc,k_proc),i_proc,k_proc ) = Tell_me_ExtFaces(i,i_proc) !for plot substitute "Tell_me_ExtFaces(i)" with "i" 
	    Face_to_Comm(Index_1(i_proc,k_proc),k_proc,i_proc ) = Tell_me_ExtFaces(k,k_proc) ! The same here	  
	    Index_1 (i_proc,k_proc) = Index_1 (i_proc,k_proc) + 1
	    exit do_ki
	 endif
       enddo
    enddo do_ki
  enddo
enddo

Index_2 = 0
do i_proc = 0, n_proc -1
   do i = 0, N_ExtVertices(i_proc) -1 
     j1 = ExtVertices_to_Glob (i,i_proc)
     do k_proc = 0, i_proc -1 
       do_ki_2 : do k =0, N_ExtVertices (k_proc) - 1
          k1 = ExtVertices_to_Glob (k,k_proc)
	  if (k1 == j1 ) then
	     Vertex_to_Comm (Index_2(i_proc,k_proc), i_proc, k_proc) = Tell_me_ExtVertices(i,i_proc)!j1
	     Vertex_to_Comm (Index_2(i_proc,k_proc), k_proc, i_proc) = Tell_me_ExtVertices(k,k_proc) !k1
	     Index_2 (i_proc,k_proc) = Index_2 (i_proc,k_proc) + 1
	     exit do_ki_2
	  endif
        enddo do_ki_2
       enddo 
   enddo
enddo

do i_proc = 0, n_proc-1
 do k_proc = i_proc+1, n_proc-1
    Index_1(i_proc, k_proc) = Index_1(k_proc,i_proc)
    Index_2(i_proc, k_proc) = Index_2(k_proc,i_proc)
 enddo
enddo

allocate (n_proc_effective (0:n_proc-1))
n_proc_effective = 0
do i_proc = 0, n_proc-1
  do k_proc = 0, n_proc -1 
    if (Index_2(i_proc,k_proc) > 0) n_proc_effective(i_proc) = n_proc_effective(i_proc) + 1
  enddo
enddo

! Define communication topology and ordering
allocate (Communication_table(0:n_proc-1,0:n_proc-1))
allocate (Logic_proc_count (0:n_proc-1))
Communication_table = -1
do i = 0, n_proc-1
   Logic_proc_count = .false.
   do i_proc = 0, n_proc-1
       if (.not. Logic_proc_count(i_proc) ) then
         dok_proc : do k_proc = 0, n_proc-1
           logic_1 = Logic_proc_count(k_proc); logic_2 = .false.
	   do k = 0, i-1	! The communication is not yet stored 
	      if (k_proc == Communication_table(i_proc,k) ) logic_2 = .true.
	   enddo
	   logic_1 = (.not. logic_1) .and. (.not. logic_2)
           if (Index_2(i_proc,k_proc) > 0 .and. logic_1) then 
	       Communication_table(i_proc,i) = k_proc
	       Communication_table (k_proc,i) = i_proc
	       Logic_proc_count(i_proc) = .true.
	       Logic_proc_count(k_proc) = .true.
	       exit dok_proc
	  endif        
       enddo dok_proc
     endif
  enddo
enddo

! Revise communication table 
do i= 0, n_proc-1
   do_k_ext : do k = 0, n_proc - 1
     logic_1 = .false.
     logic_2 = .false.
     do i_proc = 0,n_proc-1
       if (Communication_table(i,i_proc) == -1 .and. (.not. logic_1) )  then
         logic_1 = .true.
         k1 = i_proc
       endif
       if (logic_1 .and. Communication_table (i,i_proc) > -1 .and. (.not. logic_2)) then
          logic_2 = .true.
	  k2 = i_proc
       endif
       if (logic_2)  Communication_table(i,k1+i_proc-k2) = Communication_table (i,i_proc)
      enddo
      if (.not. logic_1) exit do_k_ext
   enddo do_k_ext
enddo 

if (super_object_present) then
  allocate (Index_3(0:n_proc-1,0:n_proc-1))
  allocate (SuperObject_Vertex_to_Comm(0:N_MAX_Vertex_to_Comm-1, 0:n_proc-1,0:n_proc-1))
  Index_3 = 0
  do i_proc = 0, n_proc-1
      do_of_superobject : do  n = 0, n_vertex_on_interface-1
        if (Vertex_of_SuperObject(n,i_proc) > -1) then
	    do_of_proc: do  k_proc = 0, n_proc - 1
	        do k = 0, Index_2 (i_proc,k_proc)-1 
   	             if (Vertex_of_Superobject(n,i_proc) == Vertex_to_Comm (k, i_proc,k_proc) ) then
		          SuperObject_Vertex_to_Comm (Index_3(i_proc,k_proc), i_proc, k_proc) = n
			  Index_3 (i_proc,k_proc) = Index_3 (i_proc,k_proc) + 1
			  exit do_of_proc
		     endif
		enddo
	    enddo do_of_proc 
	else if (Vertex_of_SuperObject(n,i_proc) == -1) then
	    exit do_of_superobject    
	endif
      enddo do_of_superobject
    enddo
endif
   
do i_proc = 0, n_proc-1
     open (13,file="temp_file", form="formatted")
     write (13,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
     write (13,203)  "Define super_objects for communications"
     write (13,202) n_proc, "Number of processors"
     write (13,202) n_proc_effective(i_proc), "Number of effective processors in the communication"
     do k = 0, n_proc_effective(i_proc) -1 
           k_proc = Communication_table (i_proc, k)
           write (13,202) k_proc,"processor number"
	   write (13,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"   
	   write (13,203)  "Define faces"
	   write (13,202) Index_1 (i_proc,k_proc), "number of faces"
	   do i = 0, Index_1(i_proc,k_proc) - 1
	      write (13,*) Face_to_Comm (i,i_proc,k_proc), Face_Coherency(i,i_proc,k_proc)
	   enddo
	   write (13,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"   
	   write (13,203)  "Define vertices"
	   write (13,202) Index_2 (i_proc,k_proc), "number of vertices"
	   do i = 0, Index_2(i_proc,k_proc) - 1
	      write (13,209) Vertex_to_Comm (i,i_proc,k_proc)
	   enddo
	   write (13,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"   
	   if (super_object_present) then
	   write (13,203) " Define quantities of super_object to e transferred"
	   write (13,202) Index_3 (i_proc,k_proc), "number of vertices"
	      do i = 0, Index_3(i_proc,k_proc) - 1
	        write (13,209) SuperObject_Vertex_to_Comm (i,i_proc,k_proc)
	     enddo	   
	   write (13,203)  "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"   
	   endif
     enddo
     write (13,203) " Have a good run"
     close (13)
     write (fnamef, "(a16,I2.2)") "mesh4spec.input.", i_proc
     write (gnameg,"(a18,a20)")  "cat temp_file >> ", fnamef
     call system (gnameg)
     call system ("rm -f temp_file")
    
enddo     
deallocate (Ipointer)
deallocate (Gcoord)
deallocate (Which_points_inside)
deallocate (Tell_me_ExtFaces)
deallocate (Tell_me_ExtVertices)
deallocate (Global_to_local)
deallocate (Index_1)
deallocate (Index_2)
deallocate (Face_to_Comm)
deallocate (Vertex_to_Comm)
deallocate (N_ExtFaces)
deallocate (N_ExtVertices)
deallocate (ExtFaces_to_Glob_Vertices)
deallocate (ExtVertices_to_Glob)
deallocate (n_proc_effective)
deallocate (Communication_table)
deallocate (Logic_proc_count)
deallocate (Face_Coherency)
deallocate (Elem_to_LocalElem)
if (super_object_present) then
    deallocate (Vertex_of_SuperObject)
    deallocate (SuperObject_Vertex_to_Comm)
    deallocate (Index_3)
endif
stop

201 format (3e15.7)
202 format (i8,10x,a)
203 format (a)
204 format (13i8)
205 format (17i8)
206 format (6i8)
207 format (5i8)
208 format (2i8)  
209 format (i8)
  
end program gid2spec_parallel



! #########################################################
subroutine rotate (Ipointer,Gcoord,ndim_stor,n_elem,nglob_ctlpt,n_nods,nv)

implicit none

integer, intent (IN) :: ndim_stor,n_elem,nglob_ctlpt, n_nods,nv
integer, dimension (0:ndim_stor-1,0:n_elem-1), intent (INOUT) :: Ipointer
real, dimension (0:1,0:nglob_ctlpt-1), intent (IN) :: Gcoord

!local variables
integer :: k,kp,kf,kff,n,i
integer, dimension (0:3) :: Ivect
real, dimension (0:3) :: XVect, Zvect
real :: sign
real, external :: compute_area
logical :: logic1

! The condition for the coordinates are 
! for the first point x < x (following); z< z (previous)
! for the second z <z (following)
! for the third x < x (following)
! This should be satisfy the convexity of the element

do n = 0,n_elem-1
   do k= 0,3
       Xvect(k) = Gcoord (0,Ipointer(k,n)) 
       Zvect(k) = Gcoord (1,Ipointer(k,n)) 
   enddo

sign =  compute_area(Xvect, Zvect) 

if (sign < 0) then
     if (n_nods == 4 ) then 
       do i = 0,3
           Ivect (i) = Ipointer (3-i,n)
        enddo
        Ipointer (0:3,n) = Ivect
      else
       do i = 0,3
           Ivect (i) = Ipointer (3-i,n)
        enddo
        Ipointer (0:3,n) = Ivect
       do i = 0,3
           Ivect (i) = Ipointer (7-i,n)
        enddo
        Ipointer (4:7,n) = Ivect
     endif
     do k= 0,3
       Xvect(k) = Gcoord (0,Ipointer(k,n)) 
       Zvect(k) = Gcoord (1,Ipointer(k,n)) 
     enddo
endif

   k_do : do k  = 0,3
      kf = k + 1
      kp = k - 1
      kff = k + 2
      if (k == 3) then
          kf = 0; kff = 1; 
      endif
      if (k == 0 ) kp = 3
      if (k == 2) kff = 0
      logic1 = Xvect(k) < Xvect(kf)     .and. Zvect(k) < Zvect(kp)
      logic1 = logic1 .and. Zvect(kf) < Zvect(kff)
      logic1 = logic1 .and. Xvect(kff) > Xvect(kp)
      if (logic1) exit k_do
   enddo k_do

   if (k /= 0 ) then 

   if (n_nods == 4 ) then
       Ivect(0:3) = Ipointer (0:3,n) 
       Ivect = cshift (Ivect,k)
       Ipointer (0:3,n) = Ivect (0:3)
   else if (n_nods == 8 ) then
       Ivect(0:3) = Ipointer (0:3,n) 
       Ivect = cshift (Ivect,k)
       Ipointer (0:3,n) = Ivect (0:3)
       Ivect(0:3) = Ipointer (4:7,n) 
       Ivect = cshift (Ivect,k)
       Ipointer (4:7,n) = Ivect (0:3)
       Ivect(0:3) = Ipointer(n_nods+nv:n_nods+nv+3,n) 
       Ivect = cshift (Ivect,k)
       Ipointer(n_nods+nv:n_nods+nv+3,n) = Ivect (0:3)
   endif
   endif
enddo
return
end subroutine rotate

!#####################################################
real function compute_area (X,z)
implicit none
real, dimension (0:3) :: x,z

compute_area = x(0)*z(1) + x(1)*z(2) + x(2)*z(0) - z(1)*x(2) - z(2)*x(0) - z(0) * x(1)
return
end function compute_area
! #######################################################
integer function max_value (array,n)
implicit none

integer, dimension (0:n-1) ::array
integer :: n,i, r_max

r_max = array(0)
do i  = 1, n-1
   if (r_max < array(i)) r_max = array(i)
enddo
max_value = r_max
return
end function max_value 
