subroutine allocate_domain (Tdomain)

!Modified by Gaetano Festa 01/06/2005

use sdomain;
implicit none

type(domain), intent (INOUT):: Tdomain

integer :: n,ngllx,ngllz,ngll

do n=0,Tdomain%n_elem-1
  ngllx = Tdomain%specel(n)%ngllx
  ngllz = Tdomain%specel(n)%ngllz
  allocate (Tdomain%specel(n)%MassMat(0:ngllx-1,0:ngllz-1))
  allocate (Tdomain%specel(n)%Density(0:ngllx-1,0:ngllz-1))
  allocate (Tdomain%specel(n)%Lambda(0:ngllx-1,0:ngllz-1))
  allocate (Tdomain%specel(n)%Mu(0:ngllx-1,0:ngllz-1))
  allocate (Tdomain%specel(n)%Veloc (  1:ngllx-2, 1:ngllz-2, 0:1 ) )
  allocate (Tdomain%specel(n)%Forces(  0:ngllx-1, 0:ngllz-1, 0:1 ) )
  allocate (Tdomain%specel(n)%Accel(1:ngllx-2,1:ngllz-2,0:1))
  allocate (Tdomain%specel(n)%V0(  1:ngllx-2, 1:ngllz-2, 0:1 ) )  

  Tdomain%specel(n)%Veloc = 0   
  Tdomain%specel(n)%Accel = 0  
  Tdomain%specel(n)%V0 = 0  

   if (Tdomain%specel(n)%PML ) then 
        allocate (Tdomain%specel(n)%Stress (  0:ngllx-1, 0:ngllz-1, 0:2 )) 
        allocate (Tdomain%specel(n)%Forces1 (0:ngllx-1,0:ngllz-1,0:1) ) 
        allocate (Tdomain%specel(n)%Forces2 (0:ngllx-1,0:ngllz-1,0:1) ) 
        allocate (Tdomain%specel(n)%Acoeff(0:ngllx-1,0:ngllz-1,0:15))
        allocate (Tdomain%specel(n)%Stress1 (0:ngllx-1,0:ngllz-1,0:2) ) 
        allocate (Tdomain%specel(n)%Stress2 (0:ngllx-1,0:ngllz-1,0:2) ) 
        allocate (Tdomain%specel(n)%Veloc1 (1:ngllx-2,1:ngllz-2,0:1) ) 
        allocate (Tdomain%specel(n)%Veloc2 (1:ngllx-2,1:ngllz-2,0:1) ) 
        allocate (Tdomain%specel(n)%DumpSx (0:ngllx-1,0:ngllz-1,0:1) ) 
        allocate (Tdomain%specel(n)%DumpSz (0:ngllx-1,0:ngllz-1,0:1) ) 
        allocate (Tdomain%specel(n)%DumpVx (1:ngllx-2,1:ngllz-2,0:1) ) 
        allocate (Tdomain%specel(n)%DumpVz (1:ngllx-2,1:ngllz-2,0:1) ) 
        Tdomain%specel(n)%Stress = 0.       
        Tdomain%specel(n)%Veloc1 = 0.
        Tdomain%specel(n)%Veloc2 = 0.
        Tdomain%specel(n)%Stress1 = 0.
        Tdomain%specel(n)%Stress2 = 0.
	
	if (Tdomain%specel(n)%FPML) then
	     allocate (Tdomain%specel(n)%Isx(0:ngllx-1,0:ngllz-1))
	     allocate (Tdomain%specel(n)%Isz(0:ngllx-1,0:ngllz-1))
	     allocate (Tdomain%specel(n)%Ivx(0:ngllx-1,0:ngllz-1))
	     allocate (Tdomain%specel(n)%Ivz(0:ngllx-1,0:ngllz-1))
	     allocate (Tdomain%specel(n)%IStress1(0:ngllx-1,0:ngllz-1,0:2))
	     allocate (Tdomain%specel(n)%IStress2(0:ngllx-1,0:ngllz-1,0:2))
	     allocate (Tdomain%specel(n)%IVeloc1(1:ngllx-2,1:ngllz-2,0:1))
	     allocate (Tdomain%specel(n)%IVeloc2(1:ngllx-2,1:ngllz-2,0:1))
	     allocate (Tdomain%specel(n)%DumpMass(0:ngllx-1,0:ngllz-1,0:3))	
	     Tdomain%specel(n)%IStress1 = 0.
	     Tdomain%specel(n)%IStress2 = 0.
	     Tdomain%specel(n)%IVeloc1 = 0.
	     Tdomain%specel(n)%IVeloc2 = 0.
	else
	     allocate (Tdomain%specel(n)%DumpMass(0:ngllx-1,0:ngllz-1,0:1))
	endif
   else
        allocate (Tdomain%specel(n)%Acoeff(0:ngllx-1,0:ngllz-1,0:9))
        allocate (Tdomain%specel(n)%Displ(1:ngllx-2,1:ngllz-2,0:1))
        Tdomain%specel(n)%Displ = 0    
   endif
enddo

do n = 0, Tdomain%n_face-1
 ngll = Tdomain%sFace(n)%ngll
  allocate (Tdomain%sFace(n)%MassMat(1:ngll-2))
  allocate (Tdomain%sFace(n)%Veloc (1:ngll-2, 0:1 ) )
  allocate (Tdomain%sFace(n)%Forces(1:ngll-2,0:1 ) )
  allocate (Tdomain%sFace(n)%Accel(1:ngll-2, 0:1))
  allocate (Tdomain%sFace(n)%V0( 1:ngll-2, 0:1 ) )  
  Tdomain%sFace(n)%MassMat = 0
  Tdomain%sFace(n)%Veloc = 0   
  Tdomain%sFace(n)%Accel = 0  
  Tdomain%sFace(n)%V0 = 0  
  Tdomain%sFace(n)%Forces = 0  

   if (Tdomain%sFace(n)%PML ) then 
        allocate (Tdomain%sFace(n)%Forces1 (1:ngll-2,0:1) ) 
        allocate (Tdomain%sFace(n)%Forces2 (1:ngll-2,0:1) ) 
        allocate (Tdomain%sFace(n)%Veloc1 (1:ngll-2,0:1) ) 
        allocate (Tdomain%sFace(n)%Veloc2 (1:ngll-2,0:1) ) 
        allocate (Tdomain%sFace(n)%DumpVx (1:ngll-2,0:1) ) 
        allocate (Tdomain%sFace(n)%DumpVz (1:ngll-2,0:1) ) 

        Tdomain%sFace(n)%Veloc1 = 0.
        Tdomain%sFace(n)%Veloc2 = 0.
	
	if (Tdomain%sFace(n)%FPML) then
	     allocate (Tdomain%sFace(n)%Ivx(1:ngll-2))
	     allocate (Tdomain%sFace(n)%Ivz(1:ngll-2))
	     allocate (Tdomain%sFace(n)%IVeloc1(1:ngll-2,0:1))
	     allocate (Tdomain%sFace(n)%IVeloc2(1:ngll-2,0:1))
	     allocate (Tdomain%sFace(n)%DumpMass(1:ngll-2,0:3))
	     Tdomain%sFace(n)%IVeloc1 = 0.
	     Tdomain%sFace(n)%IVeloc2 = 0.
	     Tdomain%sFace(n)%Ivx = 0.
	     Tdomain%sFace(n)%Ivz = 0.
	else
	     allocate (Tdomain%sFace(n)%DumpMass(1:ngll-2,0:1))
	endif
	Tdomain%sFace(n)%DumpMass = 0.
   else
        allocate (Tdomain%sFace(n)%Displ(1:ngll-2,0:1))
        Tdomain%sFace(n)%Displ = 0    
   endif
enddo

do n = 0, Tdomain%n_vertex-1
      allocate (Tdomain%sVertex(n)%Veloc (0:1))
      allocate (Tdomain%sVertex(n)%Forces (0:1))
      allocate (Tdomain%sVertex(n)%Accel (0:1))
      allocate (Tdomain%sVertex(n)%V0 (0:1))
      
      Tdomain%sVertex(n)%MassMat = 0
      Tdomain%sVertex(n)%Veloc = 0
      Tdomain%sVertex(n)%Accel = 0
      Tdomain%sVertex(n)%V0 = 0
      
      if (Tdomain%sVertex(n)%PML) then
        allocate (Tdomain%sVertex(n)%Forces1 (0:1) ) 
        allocate (Tdomain%sVertex(n)%Forces2 (0:1) ) 
        allocate (Tdomain%sVertex(n)%Veloc1 (0:1) ) 
        allocate (Tdomain%sVertex(n)%Veloc2 (0:1) ) 
        allocate (Tdomain%sVertex(n)%DumpVx (0:1) ) 
        allocate (Tdomain%sVertex(n)%DumpVz (0:1) ) 
	Tdomain%sVertex(n)%Veloc1 = 0
	Tdomain%sVertex(n)%Veloc2 = 0
	
		if (Tdomain%sFace(n)%FPML) then
	     allocate (Tdomain%sVertex(n)%Ivx(0:0))
	     allocate (Tdomain%sVertex(n)%Ivz(0:0))
	     allocate (Tdomain%sVertex(n)%IVeloc1(0:1))
	     allocate (Tdomain%sVertex(n)%IVeloc2(0:1))
	     allocate (Tdomain%sVertex(n)%DumpMass(0:1))
	     Tdomain%sVertex(n)%IVeloc1 = 0.
	     Tdomain%sVertex(n)%IVeloc2 = 0.
	else
	     allocate (Tdomain%sVertex(n)%DumpMass(0:1))
	endif
	Tdomain%sVertex(n)%DumpMass = 0
      else
        allocate (Tdomain%sVertex(n)%Displ(0:1))
	Tdomain%sVertex(n)%Displ = 0
     endif
enddo     
      
return
end subroutine allocate_domain
