subroutine Define_Arrays(Tdomain)

use sdomain

implicit none
type (domain),intent (INOUT), target :: Tdomain

! local variables

integer :: n,mat,ngllx,ngllz,ngll,i,j,idef,n_elem,w_face,nv_aus,nf
real :: vp,ri,rj,dx, LocMassmat_Vertex
real, external :: pow
real, dimension (:), allocatable :: LocMassMat1D, LocMassMat1D_Down
real, dimension (:,:), allocatable :: xix,etax, xiz,etaz,Jac, Rlam,Rmu,RKmod,Whei,Id,wx, wz
real, dimension (:,:), allocatable :: LocMassMat

! Gaetano Festa, modified 01/06/2004

! Attribute elastic properties from material

do n = 0, Tdomain%n_elem - 1
   
   mat = Tdomain%specel(n)%mat_index
   ngllx = Tdomain%specel(n)%ngllx
   ngllz = Tdomain%specel(n)%ngllz

    do j = 0, ngllz - 1
      do i = 0, ngllx - 1
          Tdomain%specel(n)%Density(i,j) = Tdomain%sSubDomain(mat)%Ddensity
          Tdomain%specel(n)%Lambda(i,j) = Tdomain%sSubDomain(mat)%DLambda
         Tdomain%specel(n)%Mu(i,j) = Tdomain%sSubDomain(mat)%DMu
      enddo
    enddo
      
   allocate (xix (0:ngllx-1,0:ngllz-1))
   allocate (xiz (0:ngllx-1,0:ngllz-1))      
   allocate (etax (0:ngllx-1,0:ngllz-1))
   allocate (etaz (0:ngllx-1,0:ngllz-1))
   allocate (RKmod (0:ngllx-1,0:ngllz-1))
   allocate (Whei (0:ngllx-1,0:ngllz-1))
   allocate (wx (0:ngllx-1,0:ngllz-1))
   allocate (wz (0:ngllx-1,0:ngllz-1))
   allocate (Id (0:ngllx-1,0:ngllz-1))
   allocate (Jac(0:ngllx-1,0:ngllz-1))
   allocate (Rlam(0:ngllx-1,0:ngllz-1))
   allocate (Rmu(0:ngllx-1,0:ngllz-1))

    do j = 0,ngllz-1
        do i = 0,ngllx-1
                   Whei (i,j) = Tdomain%sSubdomain(mat)%GLLwx(i)*  Tdomain%sSubdomain(mat)%GLLwz(j)
         enddo
     enddo

      xix  = Tdomain%specel(n)%InvGrad(:,:,0,0)
      xiz = Tdomain%specel(n)%InvGrad(:,:,1,0)
      etax  = Tdomain%specel(n)%InvGrad(:,:,0,1)
      etaz = Tdomain%specel(n)%InvGrad(:,:,1,1)
!  
      Jac  = Tdomain%specel(n)%Jacob
      Rlam = Tdomain%specel(n)%Lambda
      Rmu  = Tdomain%specel(n)%Mu
      RKmod = Rlam + 2. * Rmu

        Tdomain%specel(n)%MassMat  = Whei*Tdomain%specel(n)%Density*Jac
      if (.not. Tdomain%specel(n)%PML) then
          Tdomain%specel(n)%Acoeff(:,:,0) = -Whei*(RKmod*xix**2+Rmu*xiz**2) *Jac
          Tdomain%specel(n)%Acoeff(:,:,1) = -Whei*(RKmod*xix*etax+Rmu*  xiz*etaz)*Jac
          Tdomain%specel(n)%Acoeff(:,:,2) = -Whei*(Rlam+Rmu)*xix*xiz*Jac
          Tdomain%specel(n)%Acoeff(:,:,3) = -Whei*(Rlam*xix*etaz+Rmu*xiz*etax)*Jac 
          Tdomain%specel(n)%Acoeff(:,:,4) = -Whei*(RKmod*etax**2+Rmu*etaz**2)*Jac
          Tdomain%specel(n)%Acoeff(:,:,5) = -Whei*(Rlam*etax*xiz+Rmu*etaz*xix)*Jac
          Tdomain%specel(n)%Acoeff(:,:,6) = -Whei*(Rlam+Rmu)*etaz*etax*Jac
          Tdomain%specel(n)%Acoeff(:,:,7) = -Whei*(RKmod*xiz**2+Rmu*xix**2)*Jac
          Tdomain%specel(n)%Acoeff(:,:,8) = -Whei*(RKmod*xiz*etaz+Rmu*xix*etax)*Jac
          Tdomain%specel(n)%Acoeff(:,:,9) = -Whei*(RKmod*etaz**2+Rmu* etax**2)*Jac
     else     
          Tdomain%specel(n)%Acoeff(:,:,0) = Rkmod*xix
          Tdomain%specel(n)%Acoeff(:,:,1) = Rkmod*etax
          Tdomain%specel(n)%Acoeff(:,:,2) = Rlam * xiz
          Tdomain%specel(n)%Acoeff(:,:,3) = Rlam *etaz
          Tdomain%specel(n)%Acoeff(:,:,4) = Rlam*xix
          Tdomain%specel(n)%Acoeff(:,:,5) = Rlam*etax
          Tdomain%specel(n)%Acoeff(:,:,6) = Rkmod * xiz
          Tdomain%specel(n)%Acoeff(:,:,7) = Rkmod *etaz
          Tdomain%specel(n)%Acoeff(:,:,8) = Rmu*xiz
          Tdomain%specel(n)%Acoeff(:,:,9) = Rmu*etaz
          Tdomain%specel(n)%Acoeff(:,:,10) = Rmu * xix
          Tdomain%specel(n)%Acoeff(:,:,11) = Rmu *etax
          Tdomain%specel(n)%Acoeff(:,:,12) = -Whei*xix*Jac
          Tdomain%specel(n)%Acoeff(:,:,13) = -Whei*etax*Jac
          Tdomain%specel(n)%Acoeff(:,:,14) = -Whei * xiz*Jac
          Tdomain%specel(n)%Acoeff(:,:,15) = -Whei *etaz*Jac 

! Defining PML properties
 
         if (Tdomain%sSubDomain(mat)%Px) then
           idef = Tdomain%specel(n)%Iglobnum (0,0); dx = Tdomain%GlobCoord (0,idef)
           idef = Tdomain%specel(n)%Iglobnum (ngllx-1,0); dx = abs (Tdomain%GlobCoord (0,idef) -dx); 
           if (Tdomain%sSubDomain(mat)%Left) then
              do i = 0,ngllx-1
                 ri = 0.5*(1+Tdomain%sSubDomain(mat)%GLLcx(ngllx-1-i)) * float (ngllx-1)
                 vp = Rkmod(i,0)/Tdomain%specel(n)%Density(i,0)
                 vp = sqrt(vp)
                 wx(i,0:ngllz-1) = pow (ri,vp,ngllx-1,dx, Tdomain%sSubdomain(mat)%Apow,Tdomain%sSubdomain(mat)%npow)
              enddo
           else 
              do i = 0,ngllx-1
               ri = 0.5*(1+Tdomain%sSubDomain(mat)%GLLcx(i))*float (ngllx-1)
               vp = Rkmod(i,0)/Tdomain%specel(n)%Density(i,0)
               vp = sqrt(vp)
               wx(i,0:ngllz-1) = pow (ri,vp,ngllx-1,dx, Tdomain%sSubdomain(mat)%Apow,Tdomain%sSubdomain(mat)%npow)
              enddo
            endif
         else 
            wx = 0.
         endif  
         if (Tdomain%sSubDomain(mat)%Pz) then
           idef = Tdomain%specel(n)%Iglobnum (0,0); dx = Tdomain%GlobCoord (1,idef)
           idef = Tdomain%specel(n)%Iglobnum (0,ngllz-1); dx = abs (Tdomain%GlobCoord (1,idef) -dx)
           if (Tdomain%sSubDomain(mat)%Down) then
              do j = 0,ngllz-1
                    rj = 0.5*(1+Tdomain%sSubdomain(mat)%GLLcz(ngllz-1-j)) * float (ngllz-1)
                    vp = Rkmod(0,j)/Tdomain%specel(n)%Density(0,j)
                  vp = sqrt(vp)
                  wz(0:ngllx-1,j) = pow (rj,vp,ngllz-1,dx, Tdomain%sSubdomain(mat)%Apow,Tdomain%sSubdomain(mat)%npow)
             enddo
           else 
              do j = 0,ngllz-1
                  rj = 0.5*(1+Tdomain%sSubdomain(mat)%GLLcz(j)) * float (ngllz-1)
                  vp = Rkmod(0,j)/Tdomain%specel(n)%Density(0,j)
                  vp = sqrt(vp)
                  wz(0:ngllx-1,j) = pow (rj,vp,ngllz-1,dx, Tdomain%sSubdomain(mat)%Apow,Tdomain%sSubdomain(mat)%npow)
            enddo
          endif
       else 
            wz = 0.
       endif
       Id = 1
! Strong formulation for stresses
       if (Tdomain%specel(n)%FPML) then

         Tdomain%specel(n)%DumpSx(:,:,1) = (1.+Tdomain%sSubdomain(mat)%k) * Id(:,:) + 0.5 * Tdomain%sSubdomain(mat)%Dt * &
	         wx(:,:) * Tdomain%sSubdomain(mat)%freq 
         Tdomain%specel(n)%DumpSx (:,:,1) = 1./ Tdomain%specel(n)%DumpSx (:,:,1)
         Tdomain%specel(n)%DumpSx (:,:,0) = ((1+Tdomain%sSubdomain(mat)%k) * Id(:,:) - Tdomain%sSubdomain(mat)%Dt * 0.5 * & 
	         wx(:,:) * Tdomain%sSubdomain(mat)%freq) *  Tdomain%specel(n)%DumpSx(:,:,1)
	 Tdomain%specel(n)%DumpMass(:,:,0) =  Tdomain%specel(n)%Density * Whei * Jac * wx * & 
	     ( Tdomain%sSubdomain(mat)%Dt * 0.5 * Tdomain%sSubdomain(mat)%freq + Tdomain%sSubdomain(mat)%k) 
         Tdomain%specel(n)%DumpMass(:,:,1) =   Tdomain%specel(n)%Density * Whei *  Jac * wx * & 
	     (Tdomain%sSubdomain(mat)%k  - Tdomain%sSubdomain(mat)%Dt * 0.5 *  Tdomain%sSubdomain(mat)%freq) 

         Tdomain%specel(n)%DumpSz(:,:,1) = (1+Tdomain%sSubdomain(mat)%k) * Id(:,:) + 0.5 * Tdomain%sSubdomain(mat)%Dt * &
	          wz(:,:) * Tdomain%sSubdomain(mat)%freq 
         Tdomain%specel(n)%DumpSz (:,:,1) = 1./ Tdomain%specel(n)%DumpSz (:,:,1)
         Tdomain%specel(n)%DumpSz (:,:,0) = ((1+Tdomain%sSubdomain(mat)%k) * Id(:,:) - Tdomain%sSubdomain(mat)%Dt * 0.5 *  &
	        wz(:,:) * Tdomain%sSubdomain(mat)%freq) * Tdomain%specel(n)%DumpSz(:,:,1) 	 
         Tdomain%specel(n)%DumpMass(:,:,2) =  Tdomain%specel(n)%Density * Whei *  Jac * wz * & 
	        ( Tdomain%sSubdomain(mat)%Dt * 0.5 * Tdomain%sSubdomain(mat)%freq + Tdomain%sSubdomain(mat)%k ) 
         Tdomain%specel(n)%DumpMass(:,:,3) = Tdomain%specel(n)%Density * Whei  * Jac * wz * &
	        (Tdomain%sSubdomain(mat)%k  - Tdomain%sSubdomain(mat)%Dt * 0.5 *   Tdomain%sSubdomain(mat)%freq) 
	    
         Tdomain%specel(n)%Isx = Tdomain%sSubdomain(mat)%Dt * wx * Tdomain%sSubdomain(mat)%freq * Tdomain%specel(n)%DumpSx(:,:,1)     
         Tdomain%specel(n)%Isz = Tdomain%sSubdomain(mat)%Dt * wz * Tdomain%sSubdomain(mat)%freq * Tdomain%specel(n)%DumpSz(:,:,1)     
	 	     
  	 Tdomain%specel(n)%Ivx = Tdomain%specel(n)%Density * Whei * Tdomain%sSubdomain(mat)%Dt * wx * Jac * Tdomain%sSubdomain(mat)%freq 
	 Tdomain%specel(n)%Ivz = Tdomain%specel(n)%Density * Whei * Tdomain%sSubdomain(mat)%Dt * wz * Jac * Tdomain%sSubdomain(mat)%freq 
       else

         Tdomain%specel(n)%DumpSx(:,:,1) = Id(:,:) + 0.5 * Tdomain%sSubdomain(mat)%Dt * wx(:,:)
         Tdomain%specel(n)%DumpSx (:,:,1) = 1./ Tdomain%specel(n)%DumpSx (:,:,1)
         Tdomain%specel(n)%DumpSx (:,:,0) = (Id(:,:) - Tdomain%sSubdomain(mat)%Dt * 0.5 * wx(:,:)) * Tdomain%specel(n)%DumpSx(:,:,1)     
	 
         Tdomain%specel(n)%DumpSz(:,:,1) = Id(:,:) + 0.5 * Tdomain%sSubdomain(mat)%Dt * wz(:,:)
         Tdomain%specel(n)%DumpSz (:,:,1) = 1./ Tdomain%specel(n)%DumpSz (:,:,1)
         Tdomain%specel(n)%DumpSz (:,:,0) = (Id(:,:) - Tdomain%sSubdomain(mat)%Dt * 0.5 * wz(:,:)) * Tdomain%specel(n)%DumpSz(:,:,1)     

         Tdomain%specel(n)%DumpMass(:,:,0) = 0.5 * Tdomain%specel(n)%Density * Whei * Tdomain%sSubdomain(mat)%Dt * wx * Jac
         Tdomain%specel(n)%DumpMass(:,:,1) = 0.5 * Tdomain%specel(n)%Density * Whei * Tdomain%sSubdomain(mat)%Dt * wz * Jac
      endif
  endif
  deallocate (xix,xiz,etax,etaz,Id,wx,wz,Whei,RKmod, Jac, Rmu, Rlam)  

enddo

! Communication inside the processor

do nf = 0, Tdomain%n_face-1
   n_elem = Tdomain%sFace(nf)%Near_element(0)
   w_face = Tdomain%sFace(nf)%Which_face(0)
   call getMass_element2face (Tdomain,n_elem,nf,w_face,.true.)
   if (Tdomain%sFace(nf)%PML ) call getDumpMass_element2face (Tdomain,n_elem,nf,w_face,.true.)
   if (Tdomain%sFace(nf)%FPML ) call getIv_element2face (Tdomain,n_elem,nf,w_face,.true.)
   n_elem = Tdomain%sFace(nf)%Near_element(1)
   if (n_elem > -1) then
      w_face = Tdomain%sFace(nf)%Which_face(1)
      call getMass_element2face (Tdomain,n_elem,nf,w_face,Tdomain%sFace(nf)%coherency)
      if (Tdomain%sFace(nf)%PML ) call getDumpMass_element2face (Tdomain,n_elem,nf,w_face,Tdomain%sFace(nf)%coherency)
         if (Tdomain%sFace(nf)%FPML ) call getIv_element2face (Tdomain,n_elem,nf,w_face,Tdomain%sFace(nf)%coherency)
   endif
enddo

do n = 0, Tdomain%n_elem -1
      ngllx = Tdomain%specel(n)%ngllx; ngllz = Tdomain%specel(n)%ngllz
      nv_aus = Tdomain%specel(n)%Near_Vertex(0)
      Tdomain%sVertex(nv_aus)%MassMat = Tdomain%sVertex(nv_aus)%MassMat + Tdomain%specel(n)%MassMat(0,0)
      if (Tdomain%sVertex(nv_aus)%PML)    &
              Tdomain%sVertex(nv_aus)%DumpMass(:) = Tdomain%sVertex(nv_aus)%DumpMass(:)+ Tdomain%specel(n)%DumpMass(0,0,:)
      if (Tdomain%sVertex(nv_aus)%FPML) then
              Tdomain%sVertex(nv_aus)%Ivx(0) = Tdomain%sVertex(nv_aus)%Ivx(0)+ Tdomain%specel(n)%Ivx(0,0)
	      Tdomain%sVertex(nv_aus)%Ivz(0) = Tdomain%sVertex(nv_aus)%Ivz(0) + Tdomain%specel(n)%Ivz(0,0)
      endif

      nv_aus = Tdomain%specel(n)%Near_Vertex(1)
      Tdomain%sVertex(nv_aus)%MassMat = Tdomain%sVertex(nv_aus)%MassMat + Tdomain%specel(n)%MassMat(ngllx-1,0)
      if (Tdomain%sVertex(nv_aus)%PML)    &
              Tdomain%sVertex(nv_aus)%DumpMass(:) = Tdomain%sVertex(nv_aus)%DumpMass(:)+ Tdomain%specel(n)%DumpMass(ngllx-1,0,:)
      if (Tdomain%sVertex(nv_aus)%FPML) then
              Tdomain%sVertex(nv_aus)%Ivx(0) = Tdomain%sVertex(nv_aus)%Ivx(0)+ Tdomain%specel(n)%Ivx(ngllx-1,0)
	      Tdomain%sVertex(nv_aus)%Ivz(0) = Tdomain%sVertex(nv_aus)%Ivz(0) + Tdomain%specel(n)%Ivz(ngllx-1,0)
      endif

      nv_aus = Tdomain%specel(n)%Near_Vertex(2)
      Tdomain%sVertex(nv_aus)%MassMat = Tdomain%sVertex(nv_aus)%MassMat + Tdomain%specel(n)%MassMat(ngllx-1,ngllz-1)
      if (Tdomain%sVertex(nv_aus)%PML)   &
              Tdomain%sVertex(nv_aus)%DumpMass(:) = Tdomain%sVertex(nv_aus)%DumpMass(:) + &
	           Tdomain%specel(n)%DumpMass(ngllx-1,ngllz-1,:)
      if (Tdomain%sVertex(nv_aus)%FPML) then
              Tdomain%sVertex(nv_aus)%Ivx(0) = Tdomain%sVertex(nv_aus)%Ivx(0)+ Tdomain%specel(n)%Ivx(ngllx-1,ngllz-1)
	      Tdomain%sVertex(nv_aus)%Ivz(0) = Tdomain%sVertex(nv_aus)%Ivz(0) + Tdomain%specel(n)%Ivz(ngllx-1,ngllz-1)
      endif

      nv_aus = Tdomain%specel(n)%Near_Vertex(3)
      Tdomain%sVertex(nv_aus)%MassMat = Tdomain%sVertex(nv_aus)%MassMat + Tdomain%specel(n)%MassMat(0,ngllz-1)
      if (Tdomain%sVertex(nv_aus)%PML)    &
              Tdomain%sVertex(nv_aus)%DumpMass(:) = Tdomain%sVertex(nv_aus)%DumpMass(:)+ Tdomain%specel(n)%DumpMass(0,ngllz-1,:)
      if (Tdomain%sVertex(nv_aus)%FPML) then
              Tdomain%sVertex(nv_aus)%Ivx(0) = Tdomain%sVertex(nv_aus)%Ivx(0)+ Tdomain%specel(n)%Ivx(0,ngllz-1)
	      Tdomain%sVertex(nv_aus)%Ivz(0) = Tdomain%sVertex(nv_aus)%Ivz(0) + Tdomain%specel(n)%Ivz(0,ngllz-1)
      endif
enddo

! Invert Mass Matrix expression

do n  = 0, Tdomain%n_elem - 1
  ngllx = Tdomain%specel(n)%ngllx;  ngllz = Tdomain%specel(n)%ngllz
  allocate (LocMassMat(1:ngllx-2,1:ngllz-2))
! Redefinition of Matrices
  if (.not. Tdomain%specel(n)%PML ) then
      LocMassMat(:,:) = Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2)
      LocMassmat = 1./ LocMassMat
      deallocate (Tdomain%specel(n)%MassMat)
      allocate (Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2) )
      Tdomain%specel(n)%MassMat =  LocMassMat
  else
      if (Tdomain%specel(n)%FPML) then

        LocMassMat(:,:) = Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2)
        Tdomain%specel(n)%DumpVx (:,:,1) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,0)
        Tdomain%specel(n)%DumpVx (:,:,1) = 1./ Tdomain%specel(n)%DumpVx (:,:,1)
        Tdomain%specel(n)%DumpVx(:,:,0) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,1)
        Tdomain%specel(n)%DumpVx (:,:,0) =    Tdomain%specel(n)%DumpVx (:,:,0) *   Tdomain%specel(n)%DumpVx (:,:,1)

        Tdomain%specel(n)%DumpVz (:,:,1) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,2)
        Tdomain%specel(n)%DumpVz (:,:,1) = 1./ Tdomain%specel(n)%DumpVz (:,:,1)
        Tdomain%specel(n)%DumpVz(:,:,0) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,3)
        Tdomain%specel(n)%DumpVz (:,:,0) =    Tdomain%specel(n)%DumpVz (:,:,0) *   Tdomain%specel(n)%DumpVz (:,:,1)
        deallocate (Tdomain%specel(n)%MassMat) ; deallocate (Tdomain%specel(n)%DumpMass)
        allocate (Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2) )
        Tdomain%specel(n)%MassMat =  LocMassMat
	LocMassMat = Tdomain%specel(n)%Ivx(1:ngllx-2,1:ngllz-2)
	deallocate (Tdomain%specel(n)%Ivx)
	allocate (Tdomain%specel(n)%Ivx(1:ngllx-2,1:ngllz-2) )
	Tdomain%specel(n)%Ivx = LocMassMat *  Tdomain%specel(n)%DumpVx (:,:,1)
        LocMassMat = Tdomain%specel(n)%Ivz(1:ngllx-2,1:ngllz-2)
	deallocate (Tdomain%specel(n)%Ivz)
	allocate (Tdomain%specel(n)%Ivz(1:ngllx-2,1:ngllz-2) )
	Tdomain%specel(n)%Ivz = LocMassMat * Tdomain%specel(n)%DumpVz (:,:,1)

      else

        LocMassMat(:,:) = Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2)
        Tdomain%specel(n)%DumpVx (:,:,1) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,0)
        Tdomain%specel(n)%DumpVx (:,:,1) = 1./ Tdomain%specel(n)%DumpVx (:,:,1)
        Tdomain%specel(n)%DumpVx(:,:,0) = LocMassMat - Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,0)
        Tdomain%specel(n)%DumpVx (:,:,0) =    Tdomain%specel(n)%DumpVx (:,:,0) *   Tdomain%specel(n)%DumpVx (:,:,1)

        Tdomain%specel(n)%DumpVz (:,:,1) = LocMassMat + Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,1)
        Tdomain%specel(n)%DumpVz (:,:,1) = 1./ Tdomain%specel(n)%DumpVz (:,:,1)
        Tdomain%specel(n)%DumpVz(:,:,0) = LocMassMat - Tdomain%specel(n)%DumpMass(1:ngllx-2,1:ngllz-2,1)
        Tdomain%specel(n)%DumpVz (:,:,0) =    Tdomain%specel(n)%DumpVz (:,:,0) *   Tdomain%specel(n)%DumpVz (:,:,1)
        deallocate (Tdomain%specel(n)%MassMat) ; deallocate (Tdomain%specel(n)%DumpMass)
        allocate (Tdomain%specel(n)%MassMat(1:ngllx-2,1:ngllz-2) )
        Tdomain%specel(n)%MassMat =  LocMassMat
      endif
  endif
  deallocate (LocMassMat)
! deallocate (Tdomain%specel(n)%Lamda)
! deallocate (Tdomain%specel(n)%Mu)
if (.not. Tdomain%logicD%save_deformation)  deallocate (Tdomain%specel(n)%InvGrad)
enddo

do nf  = 0, Tdomain%n_face - 1
    if (Tdomain%sFace(nf)%PML ) then
         if (Tdomain%sFace(nf)%FPML) then
	    Tdomain%sFace(nf)%DumpVx (:,1) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,0)
            Tdomain%sFace(nf)%DumpVx (:,1) = 1./Tdomain%sFace(nf)%DumpVx (:,1)
            Tdomain%sFace(nf)%DumpVx (:,0) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,1)
            Tdomain%sFace(nf)%DumpVx (:,0) = Tdomain%sFace(nf)%DumpVx (:,0) *  Tdomain%sFace(nf)%DumpVx (:,1)

            Tdomain%sFace(nf)%DumpVz (:,1) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,2)
            Tdomain%sFace(nf)%DumpVz (:,1) = 1./Tdomain%sFace(nf)%DumpVz (:,1)
            Tdomain%sFace(nf)%DumpVz (:,0) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,3)
            Tdomain%sFace(nf)%DumpVz (:,0) = Tdomain%sFace(nf)%DumpVz (:,0) *  Tdomain%sFace(nf)%DumpVz (:,1)
	    Tdomain%sFace(nf)%Ivx = Tdomain%sFace(nf)%Ivx * Tdomain%sFace(nf)%DumpVx(:,1)
	    Tdomain%sFace(nf)%Ivz = Tdomain%sFace(nf)%Ivz * Tdomain%sFace(nf)%DumpVz(:,1)
            deallocate (Tdomain%sFace(nf)%DumpMass)
	 else
            Tdomain%sFace(nf)%DumpVx (:,1) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,0)
            Tdomain%sFace(nf)%DumpVx (:,1) = 1./Tdomain%sFace(nf)%DumpVx (:,1)
            Tdomain%sFace(nf)%DumpVx (:,0) =  Tdomain%sFace(nf)%MassMat - Tdomain%sFace(nf)%DumpMass(:,0)
            Tdomain%sFace(nf)%DumpVx (:,0) = Tdomain%sFace(nf)%DumpVx (:,0) *  Tdomain%sFace(nf)%DumpVx (:,1)

            Tdomain%sFace(nf)%DumpVz (:,1) =  Tdomain%sFace(nf)%MassMat + Tdomain%sFace(nf)%DumpMass(:,1)
            Tdomain%sFace(nf)%DumpVz (:,1) = 1./Tdomain%sFace(nf)%DumpVz (:,1)
            Tdomain%sFace(nf)%DumpVz (:,0) =  Tdomain%sFace(nf)%MassMat - Tdomain%sFace(nf)%DumpMass(:,1)
            Tdomain%sFace(nf)%DumpVz (:,0) = Tdomain%sFace(nf)%DumpVz (:,0) *  Tdomain%sFace(nf)%DumpVz (:,1)
            deallocate (Tdomain%sFace(nf)%DumpMass)
	 endif
    else
            Tdomain%sFace(nf)%MassMat = 1./ Tdomain%sFace(nf)%MassMat
    endif
enddo

do nv_aus = 0, Tdomain%n_vertex - 1
    if (Tdomain%sVertex(nv_aus)%PML) then
      if (tdomain%sVertex(nv_aus)%FPML) then
            Tdomain%sVertex(nv_aus)%DumpVx (1) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(0)
            Tdomain%sVertex(nv_aus)%DumpVx (1) = 1./Tdomain%sVertex(nv_aus)%DumpVx (1)
            Tdomain%sVertex(nv_aus)%DumpVx (0) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(1)
            Tdomain%sVertex(nv_aus)%DumpVx (0) = Tdomain%sVertex(nv_aus)%DumpVx (0) *  Tdomain%sVertex(nv_aus)%DumpVx (1)

            Tdomain%sVertex(nv_aus)%DumpVz (1) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(2)
            Tdomain%sVertex(nv_aus)%DumpVz (1) = 1./Tdomain%sVertex(nv_aus)%DumpVz (1)
            Tdomain%sVertex(nv_aus)%DumpVz (0) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(3)
            Tdomain%sVertex(nv_aus)%DumpVz (0) = Tdomain%sVertex(nv_aus)%DumpVz (0) *  Tdomain%sVertex(nv_aus)%DumpVz (1)
	    Tdomain%sVertex(nv_aus)%Ivx(0) = Tdomain%sVertex(nv_aus)%Ivx(0) * Tdomain%sVertex(nv_aus)%DumpVx(1)
	    Tdomain%sVertex(nv_aus)%Ivz(0) = Tdomain%sVertex(nv_aus)%Ivz(0) * Tdomain%sVertex(nv_aus)%DumpVz(1)

             deallocate (Tdomain%sVertex(nv_aus)%DumpMass)
      else
            Tdomain%sVertex(nv_aus)%DumpVx (1) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(0)
            Tdomain%sVertex(nv_aus)%DumpVx (1) = 1./Tdomain%sVertex(nv_aus)%DumpVx (1)
            Tdomain%sVertex(nv_aus)%DumpVx (0) =  Tdomain%sVertex(nv_aus)%MassMat - Tdomain%sVertex(nv_aus)%DumpMass(0)
            Tdomain%sVertex(nv_aus)%DumpVx (0) = Tdomain%sVertex(nv_aus)%DumpVx (0) *  Tdomain%sVertex(nv_aus)%DumpVx (1)

            Tdomain%sVertex(nv_aus)%DumpVz (1) =  Tdomain%sVertex(nv_aus)%MassMat + Tdomain%sVertex(nv_aus)%DumpMass(1)
            Tdomain%sVertex(nv_aus)%DumpVz (1) = 1./Tdomain%sVertex(nv_aus)%DumpVz (1)
            Tdomain%sVertex(nv_aus)%DumpVz (0) =  Tdomain%sVertex(nv_aus)%MassMat - Tdomain%sVertex(nv_aus)%DumpMass(1)
            Tdomain%sVertex(nv_aus)%DumpVz (0) = Tdomain%sVertex(nv_aus)%DumpVz (0) *  Tdomain%sVertex(nv_aus)%DumpVz (1)
             deallocate (Tdomain%sVertex(nv_aus)%DumpMass)
       endif
     else
             Tdomain%sVertex(nv_aus)%MassMat = 1./Tdomain%sVertex(nv_aus)%MassMat
     endif
enddo

! Define Fault properties
if (Tdomain%logicD%super_object) then
   do nf = 0, Tdomain%n_fault-1
     do j = 0, Tdomain%sFault(nf)%n_vertex-1
         Tdomain%sFault(nf)%fVertex(j)%Bt  = 0
     enddo

     ! Internal communication of BT
     do j = 0, Tdomain%sFault(nf)%n_face-1
        ngll = Tdomain%sFault(nf)%fFace(j)%ngll
	mat = Tdomain%sFault(nf)%fFace(j)%mat_index
	if (Tdomain%sFault(nf)%fFace(j)%mat_dir ==0 ) then
        	Tdomain%sFault(nf)%fFace(j)%Bt = Tdomain%sFault(nf)%fFace(j)%ds * Tdomain%sSubdomain(mat)%GLLwx
	else
	        Tdomain%sFault(nf)%fFace(j)%Bt = Tdomain%sFault(nf)%fFace(j)%ds * Tdomain%sSubdomain(mat)%GLLwz
	endif
        nv_aus = Tdomain%sFault(nf)%fFace(j)%Face_to_Vertex(0)
	Tdomain%sFault(nf)%fVertex(nv_aus)%Bt = Tdomain%sFault(nf)%fVertex(nv_aus)%Bt + Tdomain%sFault(nf)%fFace(j)%Bt(0)
	nv_aus = Tdomain%sFault(nf)%fFace(j)%Face_to_Vertex(1)
	Tdomain%sFault(nf)%fVertex(nv_aus)%Bt = Tdomain%sFault(nf)%fVertex(nv_aus)%Bt + Tdomain%sFault(nf)%fFace(j)%Bt(ngll-1)
     enddo

     do j = 0, Tdomain%sFault(nf)%n_face-1
       ngll = Tdomain%sFault(nf)%fFace(j)%ngll
       mat = Tdomain%sFault(nf)%fFace(j)%mat_index
       allocate (LocMassMat1D(1:ngll-2))
       allocate (LocMassMat1D_Down(1:ngll-2))
       nv_aus = Tdomain%sFault(nf)%fFace(j)%Face_UP
       LocMassMat1D = Tdomain%sFace(nv_aus)%MassMat
       nv_aus = Tdomain%sFault(nf)%fFace(j)%Face_DOWN
        if (Tdomain%sFault(nf)%fFace(j)%Coherency) then
             LocMassMat1D_Down =  Tdomain%sFace(nv_aus)%MassMat
        else
            do i = 0, ngll-1
	        LocMassMat1D_Down(i) =  Tdomain%sFace(nv_aus)%MassMat(ngll-i-1)
	    enddo
       endif
       LocMassMat1D =  LocMassMat1D + LocMassMat1D_Down
       Tdomain%sFault(nf)%fFace(j)%CGamma= LocMassMat1D * Tdomain%sSubDomain(mat)%Dt * Tdomain%sFault(nf)%fFace(j)%Bt(1:ngll-2)
       deallocate (LocMassMat1D, LocMassMat1D_Down)
     enddo

     do j = 0, Tdomain%sFault(nf)%n_vertex-1
       mat = Tdomain%sFault(nf)%fVertex(j)%mat_index
       nv_aus = Tdomain%sFault(nf)%fVertex(j)%Vertex_UP
       LocMassMat_Vertex = Tdomain%sVertex(nv_aus)%MassMat
       nv_aus = Tdomain%sFault(nf)%fVertex(j)%Vertex_DOWN
       LocMassMat_Vertex =  LocMassMat_Vertex+ Tdomain%sVertex(nv_aus)%MassMat
       Tdomain%sFault(nf)%fVertex(j)%CGamma= LocMassMat_Vertex * Tdomain%sSubDomain(mat)%Dt * Tdomain%sFault(nf)%fVertex(j)%Bt
     enddo
 enddo
endif
return
end subroutine define_arrays

