subroutine save_deformation (Tdomain,it)
! Modified by Gaetano Festa 01/06/2005

use sdomain

implicit none
type (domain), intent (IN):: TDomain
integer, intent (IN) :: it

! local variables
integer :: ngllx,ngllz,ipoint, i,j,n, mat,nf
real, dimension(:,:) ,allocatable  :: Grad_u
real, dimension (:), allocatable  :: Wheight
real, dimension (:,:), allocatable :: Disp
real, dimension (:,:,:), allocatable :: Loc_grad_U , Grad_x, Displ
real, dimension (:,:), pointer :: hTprime, hprime

character(len=30) :: fnamef

allocate (Grad_u(0:3,0:Tdomain%n_glob_points-1))
allocate (Wheight(0:Tdomain%n_glob_points-1))
Grad_u = 0
Wheight = 0
 do n = 0,Tdomain%n_elem-1
   if (.not. Tdomain%specel(n)%PML) then
    ngllx = Tdomain%specel(n)%ngllx;  ngllz = Tdomain%specel(n)%ngllz
    allocate (Loc_Grad_U(0:ngllx-1,0:ngllz-1,0:3))
    allocate (Grad_x(0:ngllx-1,0:ngllz-1,0:3))
    allocate  (Disp (0:ngllx-1,0:ngllz-1))
    allocate (Displ(0:ngllx-1,0:ngllz-1,0:1))

    nf = Tdomain%specel(n)%near_face(0)
    if ( Tdomain%sFace(nf)%near_element(0) == n) then
                Displ(1:ngllx-2,0,0) =  Tdomain%sFace(nf)%Displ(:,0)
                Displ(1:ngllx-2,0,1) =  Tdomain%sFace(nf)%Displ(:,1)
    else
          if ( Tdomain%sFace(nf)%coherency) then
                Displ(1:ngllx-2,0,0) =  Tdomain%sFace(nf)%Displ(:,0)
                Displ(1:ngllx-2,0,1) =  Tdomain%sFace(nf)%Displ(:,1)
          else
                 do i = 1, ngllx-2
                      Displ(i,0,0) =  Tdomain%sFace(nf)%Displ(ngllx-1-i,0)
                      Displ(i,0,1) =  Tdomain%sFace(nf)%Displ(ngllx-1-i,1)
                  enddo
          endif
    endif

    nf = Tdomain%specel(n)%near_face(1)
    if ( Tdomain%sFace(nf)%near_element(0) == n) then
      Displ(ngllx-1,1:ngllz-2,0) =  Tdomain%sFace(nf)%Displ(:,0)
      Displ(ngllx-1,1:ngllz-2,1) =  Tdomain%sFace(nf)%Displ(:,1)
   else
          if ( Tdomain%sFace(nf)%coherency) then
                 Displ(ngllx-1,1:ngllz-2,0)=  Tdomain%sFace(nf)%Displ(:,0)
                 Displ(ngllx-1,1:ngllz-2,1)=  Tdomain%sFace(nf)%Displ(:,1)
          else
                 do i = 1, ngllz-2
                      Displ(ngllx-1,i,0) =  Tdomain%sFace(nf)%Displ(ngllz-1-i,0)
                       Displ(ngllx-1,i,1) =  Tdomain%sFace(nf)%Displ(ngllz-1-i,1)
                  enddo
          endif
    endif
    nf = Tdomain%specel(n)%near_face(2)
    if ( Tdomain%sFace(nf)%near_element(0) == n) then
      Displ(1:ngllx-2,ngllz-1,0) =  Tdomain%sFace(nf)%Displ(:,0)
      Displ(1:ngllx-2,ngllz-1,1) =  Tdomain%sFace(nf)%Displ(:,1)
   else
          if ( Tdomain%sFace(nf)%coherency) then
                Displ(1:ngllx-2,ngllz-1,0) =  Tdomain%sFace(nf)%Displ(:,0)
                 Displ(1:ngllx-2,ngllz-1,1) =  Tdomain%sFace(nf)%Displ(:,1)
          else
                 do i = 1, ngllx-2
                       Displ(i,ngllz-1,0) =  Tdomain%sFace(nf)%Displ(ngllx-1-i,0)
                       Displ(i,ngllz-1,1) =  Tdomain%sFace(nf)%Displ(ngllx-1-i,1)
                  enddo
          endif
    endif

   nf = Tdomain%specel(n)%near_face(3)
   if ( Tdomain%sFace(nf)%near_element(0) == n) then
      Displ(0,1:ngllz-2,0) =  Tdomain%sFace(nf)%Displ(:,0)
      Displ(0,1:ngllz-2,1) =  Tdomain%sFace(nf)%Displ(:,1)
   else
          if ( Tdomain%sFace(nf)%coherency) then
                 Displ(0,1:ngllz-2,0)=  Tdomain%sFace(nf)%Displ(:,0)
                 Displ(0,1:ngllz-2,1)=  Tdomain%sFace(nf)%Displ(:,1)
          else
                 do i = 1, ngllz-2
                       Displ(0,i,0) =  Tdomain%sFace(nf)%Displ(ngllz-1-i,0)
                       Displ(0,i,1) =  Tdomain%sFace(nf)%Displ(ngllz-1-i,1)
                  enddo
          endif
    endif

    nf = Tdomain%specel(n)%Near_Vertex(0)
    Displ(0,0,0:1) = Tdomain%sVertex(nf)%Displ(0:1)
    nf = Tdomain%specel(n)%Near_Vertex(1)
    Displ(ngllx-1,0,0:1) = Tdomain%sVertex(nf)%Displ(0:1)
    nf = Tdomain%specel(n)%Near_Vertex(2)
    Displ(ngllx-1,ngllz-1,0:1) = Tdomain%sVertex(nf)%Displ(0:1)
    nf = Tdomain%specel(n)%Near_Vertex(3)
    Displ(0,ngllz-1,0:1) = Tdomain%sVertex(nf)%Displ(0:1)

    Displ(1:ngllx-2,1:ngllz-2,0:1) = Tdomain%specel(n)%Displ(:,:,0:1)

    mat = Tdomain%specel(n)%mat_index
    hTprime => Tdomain%sSubdomain(mat)%HTprimex
    hprime => Tdomain%sSubdomain(mat)%Hprimez

    Disp=Displ(:,:,0)
    Loc_Grad_U(:,:,0) =MATMUL (hTprime, Disp)   ! dux_dxi
    Loc_Grad_U (:,:,1) = MATMUL (Disp, hprime) ! dux_deta
     Disp = Displ(:,:,1)
    Loc_Grad_U(:,:,2) =MATMUL (hTprime, Disp)   ! duz_dxi
    Loc_Grad_U (:,:,3) = MATMUL (Disp, hprime) ! duz_deta

    Grad_x (:,:,0) = Loc_Grad_U(:,:,0) * Tdomain%specel(n)%Invgrad(:,:,0,0) + Loc_Grad_U (:,:,1) *  &
           Tdomain%specel(n)%Invgrad(:,:,0,1)   ! dux_dx
    Grad_x (:,:,1) = Loc_Grad_U(:,:,0) * Tdomain%specel(n)%Invgrad(:,:,1,0) + Loc_Grad_U (:,:,1) *  &
           Tdomain%specel(n)%Invgrad(:,:,1,1)   ! dux_dz
     Grad_x (:,:,2) = Loc_Grad_U(:,:,2) * Tdomain%specel(n)%Invgrad(:,:,0,0) + Loc_Grad_U (:,:,3) *  &
           Tdomain%specel(n)%Invgrad(:,:,0,1)  ! duz_dx
    Grad_x (:,:,3) = Loc_Grad_U(:,:,2) * Tdomain%specel(n)%Invgrad(:,:,1,0) + Loc_Grad_U (:,:,3) *  &
           Tdomain%specel(n)%Invgrad(:,:,1,1)! duz_dz

        do j = 0,ngllz-1
          do i = 0,ngllx-1
               ipoint = Tdomain%specel(n)%Iglobnum(i,j)
               Grad_u (0,ipoint) = Grad_x(i,j,0) * Tdomain%specel(n)%Jacob(i,j) +   Grad_u (0,ipoint)
	       Grad_u (1,ipoint) = Grad_x(i,j,1) * Tdomain%specel(n)%Jacob(i,j) +   Grad_u (1,ipoint)
	       Grad_u (2,ipoint) = Grad_x(i,j,2) * Tdomain%specel(n)%Jacob(i,j) +   Grad_u (2,ipoint)
	       Grad_u (3,ipoint) = Grad_x(i,j,3) * Tdomain%specel(n)%Jacob(i,j) +   Grad_u (3,ipoint)
               Wheight (ipoint) = Wheight (ipoint) + Tdomain%specel(n)%Jacob(i,j)
           enddo
        enddo
	deallocate (Loc_Grad_U, Grad_x, Disp, Displ)
   endif
enddo

do n = 0, Tdomain%n_glob_points-1
   if (abs(Grad_u(0,n)) < 1e-40) Grad_u(0,n) = 0.
   if (abs(Grad_u(1,n)) < 1e-40) Grad_u(1,n) = 0.
   if (abs(Grad_u(2,n)) < 1e-40) Grad_u(2,n) = 0.
   if (abs(Grad_u(3,n)) < 1e-40) Grad_u(3,n) = 0.
   if (Wheight (n) > 0 )  Grad_u(:,n) = Grad_u(:,n) / Wheight(n)
enddo

! Dump field
write(fnamef,"(a,I5.5)")"epsilon_plus.", (it+1)/10
open (71,file=fnamef,status="unknown",form="formatted")
write(fnamef,"(a,I5.5)")"epsilon_minus.", (it+1)/10
open (72,file=fnamef,status="unknown",form="formatted")
do ipoint=0,Tdomain%n_glob_points-1
  if (Wheight (ipoint) > 0  ) then
      write (71,"(3G17.8)") Tdomain%GlobCoord (0,ipoint), Tdomain%GlobCoord (1,ipoint), Grad_u(0,ipoint) + Grad_u(3,ipoint)
      write (72,"(3G17.8)") Tdomain%GlobCoord (0,ipoint), Tdomain%GlobCoord (1,ipoint), sqrt((Grad_u(0,ipoint) - &
            Grad_u(3,ipoint))**2 + 4.* Grad_u(1,ipoint) * Grad_u(2,ipoint))
   endif
enddo
call flush(71); call flush (72)
close(71); close (72)


deallocate (Wheight, Grad_u)
return
end subroutine
