subroutine save_fault_trace (Tdomain, it)

use sdomain
implicit none
type (domain), intent (IN) :: Tdomain
integer, intent (IN) :: it

integer :: i, j, nv, n
real :: dum0, dum1
character (len=30) :: fnamef

! local variables
do n = 0,Tdomain%n_fault-1
   write(fnamef,"(a,I5.5)")"slip_v.", (it+1)/10
   open(62,file=fnamef)
    write(fnamef,"(a,I5.5)")"traction.", (it+1)/10
   open(63,file=fnamef)
    write(fnamef,"(a,I5.5)")"slip_vn.", (it+1)/10
   open(64,file=fnamef)
    write(fnamef,"(a,I5.5)")"tractionn.", (it+1)/10
     open(65,file=fnamef)
    write(fnamef,"(a,I5.5)")"slip.", (it+1)/10
   open(66,file=fnamef)

   write (62,"(a2)") ">>"
   write (63,"(a2)") ">>"
   write (64,"(a2)") ">>"
   write (65,"(a2)") ">>"
   write (66,"(a2)") ">>"

   do j = 0, Tdomain%sFault(n)%n_face-1

	nv = Tdomain%sFault(n)%fFace(j)%Face_to_Vertex(0)
	write (62,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0),Tdomain%sFault(n)%fFace(j)%Z_Vertex(0), &        
                Tdomain%sFault(n)%fVertex(nv)%Deltav(0)
	write (63,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0),Tdomain%sFault(n)%fFace(j)%Z_Vertex(0), & 
                    Tdomain%sFault(n)%fVertex(nv)%normal(1) * &
	        Tdomain%sFault(n)%fVertex(nv)%Traction(0) - Tdomain%sFault(n)%fVertex(nv)%normal(0) * &
	                 Tdomain%sFault(n)%fVertex(nv)%Traction(1)
	write (64,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0),Tdomain%sFault(n)%fFace(j)%Z_Vertex(0), & 
              Tdomain%sFault(n)%fVertex(nv)%Deltav(1)
	write (65,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0), Tdomain%sFault(n)%fFace(j)%Z_Vertex(0), &
               Tdomain%sFault(n)%fVertex(nv)%normal(0) * &
	        Tdomain%sFault(n)%fVertex(nv)%Traction(0) + Tdomain%sFault(n)%fVertex(nv)%normal(1) * &
	                 Tdomain%sFault(n)%fVertex(nv)%Traction(1)
	write (66,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0), Tdomain%sFault(n)%fFace(j)%Z_Vertex(0), & 
               Tdomain%sFault(n)%fVertex(nv)%Deltau(0)

        dum0 = 0.5 *  (Tdomain%sFault(n)%fFace(j)%X_Vertex(1)-Tdomain%sFault(n)%fFace(j)%X_Vertex(0))
        dum1 = 0.5 *  (Tdomain%sFault(n)%fFace(j)%Z_Vertex(1)-Tdomain%sFault(n)%fFace(j)%Z_Vertex(0))

        do i = 1, Tdomain%sFault(n)%fFace(j)%ngll-2
           write (62,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum0, &
                Tdomain%sFault(n)%fFace(j)%Z_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum1, &
		  Tdomain%sFault(n)%fFace(j)%Deltav(i,0)
	   write (63,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum0,   &
	        Tdomain%sFault(n)%fFace(j)%Z_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum1, &
	          Tdomain%sFault(n)%fFace(j)%normal(i,1) * &
	            Tdomain%sFault(n)%fFace(j)%Traction(i,0) -  Tdomain%sFault(n)%fFace(j)%normal(i,0) * &
	              Tdomain%sFault(n)%fFace(j)%Traction(i,1)
           write (64,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum0,  &
                Tdomain%sFault(n)%fFace(j)%Z_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum1, &
	          Tdomain%sFault(n)%fFace(j)%Deltav(i,1)
	   write (65,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum0, &
                Tdomain%sFault(n)%fFace(j)%Z_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum1, &
	          Tdomain%sFault(n)%fFace(j)%normal(i,0) * &
  	            Tdomain%sFault(n)%fFace(j)%Traction(i,0) +  Tdomain%sFault(n)%fFace(j)%normal(i,1) * &
	              Tdomain%sFault(n)%fFace(j)%Traction(i,1)
	   write (66,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum0,   &
                Tdomain%sFault(n)%fFace(j)%Z_Vertex(0) + (1. + Tdomain%sSubdomain(0)%GLLcx(i))*dum1, &
	          Tdomain%sFault(n)%fFace(j)%Deltau(i,0)
        enddo

	nv = Tdomain%sFault(n)%fFace(j)%Face_to_Vertex(1)
	write (62,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(1),Tdomain%sFault(n)%fFace(j)%Z_Vertex(1),& 
              Tdomain%sFault(n)%fVertex(nv)%Deltav(0)
	write (63,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(1),Tdomain%sFault(n)%fFace(j)%Z_Vertex(1), &
               Tdomain%sFault(n)%fVertex(nv)%normal(1) * &
	        Tdomain%sFault(n)%fVertex(nv)%Traction(0) - Tdomain%sFault(n)%fVertex(nv)%normal(0) * &
	                 Tdomain%sFault(n)%fVertex(nv)%Traction(1)
	write (64,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(1),Tdomain%sFault(n)%fFace(j)%Z_Vertex(1), &
               Tdomain%sFault(n)%fVertex(nv)%Deltav(1)
	write (65,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(1), Tdomain%sFault(n)%fFace(j)%Z_Vertex(1), &
               Tdomain%sFault(n)%fVertex(nv)%normal(0) * &
	        Tdomain%sFault(n)%fVertex(nv)%Traction(0) + Tdomain%sFault(n)%fVertex(nv)%normal(1) * &
	                 Tdomain%sFault(n)%fVertex(nv)%Traction(1)
	write (66,*)Tdomain%sFault(n)%fFace(j)%X_Vertex(1), Tdomain%sFault(n)%fFace(j)%Z_Vertex(1), Tdomain%sFault(n)%fVertex(nv)%Deltau(0)

        write (62,"(a2)") ">>"
        write (63,"(a2)") ">>"
        write (64,"(a2)") ">>"
        write (65,"(a2)") ">>"
        write (66,"(a2)") ">>"
   enddo
enddo

call flush(62); close (62); call flush(63); close(63); call flush (64); close (64); call flush (65); close (65)

end subroutine save_fault_trace
