# Plotting shell for the fields
echo 'Do you want plot the surfaces ?(yes or no)'
set answer=($<)

# Define a palette of color 
echo ' Do you want to use makecpt for generating the palette ? (yes/no)'
set sec_answer=($<)
if ($sec_answer == yes) then
   echo 'To use makecpt you have to specify...'
   echo '(a) The palette color'
   set palette=($<)
   echo '(b) The minimum , the maximum value, the interval of the palette '
   set pm=($<)
   set pM=($<)
   set pin=($<)
   makecpt -C$palette -Z -T$pm/$pM/$pin  > pala.cpt
else
    echo ' The palette should be in the file pala.cpt'
endif
echo
echo 'Do you want to plot  .....'
echo 'The epsilon_plus (1)  '
echo ' The epsilon_minus (2)'
echo ' The epsi_point (3)'
set sec_answer=($<)

if ($sec_answer == 1) then
   ls epsilon_plus.* > index
   sed 's/epsilon_plus./epsilon_plus /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
else if ($sec_answer == 2) then
   ls epsilon_minus.* > index
   sed 's/epsilon_minus./epsilon_minus /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
else
   ls epsi_point.* > index
   sed 's/epsi_point./epsi_point /' index > index_aus
   rm -f index
   awk '{print $2}' index_aus > index
   rm -f index_aus   
endif

if ($sec_answer == 1) then
   set orig = "epsilon_plus."
else if ($sec_answer == 2) then
   set orig = "epsilon_minus."
else
   set orig = "epsi_point."
endif

echo
echo 'Define the minimum and the maximum field values....'
set pm=($<)
set pM=($<)
echo
echo 'To use surface and plot commands you should introduce ... '
echo '(a) The interval of sampling (-I)'
set iv=($<)
echo '(b) The minimum, maximum values for both x and z directions (-R)'
set rm=($<)
set rM=($<)
set Rm=($<)
set RM=($<)
echo '(c) The dimensions of the picture (-JX) '
set jxm=($<)
set jxM=($<)

set i = $pm
while ($i<$pM)
  set ip = $i"p"
  set fin = `sed -n $ip index`
  set data2_fin = $orig$fin
  set fing = $data2_fin".grd"
  set fina = $data2_fin".ps"
  set finepsi = $data2_fin".epsi"
  set fingif =  $data2_fin".gif"



  surface  $data2_fin -G$fing -I$iv -R$rm/$rM/$Rm/$RM -V -T1
  if ($answer == 'yes') then
    grdimage $fing -Cpala.cpt -JX$jxm/$jxM -R -V -K -P > $fina
    psxy surface.gnu -JX -R -M -W1.5p/255/255/255 -O >> $fina
  else
    grdimage $fing -Cpala.cpt -JX$jxm/$jxM -R -V -P -B > $fina
  endif

  setenv LANG C; ps2epsi $fina
  convert $finepsi $fingif

@ i++
end
echo 
echo 'Do you want erase epsi files?(yes or no)'
set answer=($<)
rm -f *grd *ps 
if ($answer == 'yes') then
    rm -f *epsi
endif
set final_file=$orig"movie.gif"
rm -f $final_file
convert -delay 50 -loop 1000 -colors 256 $orig"*.gif" $final_file
mozilla-firefox $final_file
exit 0
